//
//  include canvas_object.h
//

// general window object to be displayed on a canvas

class display_window;//extern taken away by danjie
class display_canvas;//extern taken away by danjie

struct canvas_object
{
	display_window* parent_window;	//  parent display window
	display_canvas* parent_canvas;	//  parent display canvas
	Canvas canvas;			//  drawing canvas

	int state;			// 0 - not shown, 1 - displayed
	int able_fg; 			// 1 - enable
	int redraw_fg; 			// 1 - redraw when processing
	string  type_str;		// window type name
	string  name;			// window name
	int index;			// object index
public:
		canvas_object(display_window*,char*,char*,int);
		~canvas_object();

	virtual void set_wx(int) {}
	virtual void set_wy(int) {}
	virtual int get_wx() { return 0; }
	virtual int get_wy() { return 0; }

	void	set_able_fg(int fg) { able_fg = fg; }
	void	set_redraw_fg(int fg) { redraw_fg = fg; }
	void	set_index(int i) { index = i; }
	void	set_type_str(char* str) { strcpy(type_str,str); }
	void	set_name(char* str) { strcpy(name,str); }

	int	get_able_fg() { return able_fg; }
	int	get_redraw_fg() { return redraw_fg; }
	int 	get_index() { return index; }
	char* 	get_name() { return name; }
	char* 	get_type_str() { return type_str; }

	void 	enable() { able_fg = 1; }
	void 	disable() { able_fg = 0; }

	virtual void	print(ostream&);
	virtual void	read_from_database() {}
	virtual void	write_to_database() {}
	virtual void	display() {}
	virtual void	display(int its,float dt) {}
	virtual void	display(int it0,int it1,float dt) {}
// draw
	virtual void batch() {}
	virtual void draw(num_type,num_type) {}
	virtual void draw(num_type,num_type,int,float) {}
};

// canvas lists

typedef canvas_object* canvas_type;
declare(gslist,canvas_type);

typedef gslist(canvas_type) canvas_type_list;
typedef gslist_iterator(canvas_type) canvas_type_iterator;

