/**************************************************************/
/*                                                            */
/*                       nsl_file.h 		              */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

//static char SccsId[] = "%W%  %G%"; /* SCCS */

struct nsl_file
{
	string dname;	// directory name
        string fname;	// file name (w/ file ending)
        string name;	// file name (w/o file ending)
	string fullname;// full name including dir and file
	fstream* file;	// stream file
	int fd;		// file descriptor
        int index;	// file index
	int io_type; 	// 0 - input, 1 - output
	int type; 	// 0 - nsl, 1 - log, 2 - dat, 3 - ras, 4 - ps
	int able_fg;	// 0 - off, 1 - on
	int status;
	int auto_index_fg; // auto indexing
	int version_num;// version number
	int level_num;	// suffix level
	
public:
		nsl_file(char*);
		nsl_file();
		~nsl_file();

	void set_dname(char* str) { strcpy(dname,str); }
	char* get_dname() { return dname; }

	void set_fname(char* str) { strcpy(fname,str); }
	char* get_fname() { return fname; }

	void set_name(char* str) { strcpy(name,str); }
	char* get_name() { return name; }

	void set_fullname(char* str) { strcpy(fullname,str); }
	void set_fullname(); // set according to all pars
	char* get_fullname() { return fullname; }

	void set_file_stream(fstream* f) { file = f; }
	fstream* get_file_stream() { return file; }

	void set_index(int i) { index = i; }
	int  get_index() { return index; }
	
	void set_io_type(int i) { io_type = i; }
	int  get_io_type() { return io_type; }

	void set_type(int i) { type = i; }
	int  get_type() { return type; }

	void enable() { able_fg = 1; }
	void disable() { able_fg = 0; }
	void set_able_fg(int i) { able_fg = i; }
	int  get_able_fg() { return able_fg; }

	int load();
	int read();
	int write();
	int open(int);
	int open();
	int close();

	int attach_stdin();
	int attach_stdout();

	void print_status(ostream&);
};

// file list 
typedef nsl_file* file_type_ptr;
declare(gslist,file_type_ptr);

typedef gslist_iterator(file_type_ptr) file_type_iterator;
typedef gslist(file_type_ptr) file_type_list;


