/****************************************************************/
/*                                                           	*/
/*                       nsl_include.h                          */
/*                                                            	*/
/* by Alfredo Weitzenfeld 					*/
/*                                                            	*/
/****************************************************************/

# include "nsl.h"
# include "nsl_headers.h" 
# include "nsl_library.h"

# define ENDL "\n"

# define INPUT_MAT(a,x,y) 		\
static nsl_input_matrix a(#a,x,y)	\

# define INPUT_VEC(a,x) 		\
static nsl_input_vector a(#a,x)	\

# define INPUT_DAT(a) 			\
static nsl_input_data a(#a)		\

# define MATRIX(a,x,y) 			\
static nsl_matrix a(#a,x,y)		\

# define VECTOR(a,x) 			\
static nsl_vector a(#a,x)		\

# define ROW_VEC(a,x) 			\
static nsl_vector a(#a,x,0)		\

# define COL_VEC(a,x) 			\
static nsl_vector a(#a,x,1)		\

# define DATA(a) 			\
static nsl_data a(#a)			\

# define NETWORK(a) 			\
nsl_network a(#a);  			\

//   - MODULE, process for all t
// 1 - INIT_MODULE, process at t=0 only
// 2 - RUN_MODULE, process at t>0 only

# define MODULE(a) 			\
void a();				\
nsl_module a##_mod(#a,a);		\
void a()				\

# define INIT_MODULE(a) 		\
void a();				\
nsl_module a##_mod(#a,a,1);		\
void a()				\

# define RUN_MODULE(a) 			\
void a();				\
nsl_module a##_mod(#a,a,2);		\
void a()				\

# define FUNC_MODULE(a) 		\
void a();				\
nsl_module a##_mod(#a,a,-1);		\
void a()				\

// old compatibility

# define diff(a,b,c) a = NSLeuler(a,c,b)
# define NSLsigmoid NSLsigma
# define NSLsaturation NSLsat

// interpreter cmds
extern int nsl_get_str(istream&,char*);
extern int (*NSL_USER_CMD)(istream&);

// model
extern nsl_network* NSL_MODEL;
extern nsl_interpreter NSL;

