//
//	nsl_input_matrix.h
//

// input matrix

class nsl_input_matrix : public nsl_matrix
{
	int xz,yz;			// matrix zero elements
	float dx,dy;			// adjacent elem distance
//	float erf;              	// erf - excit. receptive field (dia)
	int overlap_fg;			// overlap
	int stim_total;			// stim list total
	nsl_stim_list* stim_list;	// stim list

public:

	nsl_input_matrix(char*,int,int);
	~nsl_input_matrix();

// set
	void	set_stim_list(nsl_stim_list* l) { stim_list = l; }
	void	set_overlapfg(int i) { overlap_fg = i; }
	void	set_xz(int i) { xz = i; }
	void	set_yz(int i) { yz = i; }
	void	set_dx(float s) { dx = s; }
	void	set_dy(float s) { dy = s; }
// get
	nsl_stim_list*	get_stim_list() { return stim_list; }
	nsl_stim_obj* get_stim(int);
	nsl_stim_obj* get_stim(char*);
	int	get_stim_total() { return stim_total; }
	int	get_overlapfg() { return overlap_fg; }
	int	get_xz() { return xz; }
	int	get_yz() { return yz; }
	float	get_dx() { return dx; }
	float	get_dy() { return dy; }

// 	assignment
void 	operator=(nsl_input_matrix&);
void 	operator=(nsl_matrix&);
void 	operator=(nsl_data&);
// void 	operator=(num_type**);
void 	operator=(num_type);

	void clear_stim();
	void copy_stim(nsl_input_matrix&);

	nsl_block_matrix* init_block_stim();
	nsl_icon_matrix* init_icon_stim();

	void run();

// print status
	void print_status(ostream&); // virtual
	void print_layer_status(ostream&); // local

	void print_stim(ostream&);
	void print_stim(ostream&,int);
};

typedef nsl_input_matrix NSL_INPUT_MATRIX;
