/****************************************************************/
/*                                                           	*/
/*                       nsl_library.h                        	*/
/*                                                            	*/
/* by Alfredo Weitzenfeld 					*/
/*                                                            	*/
/****************************************************************/

// main
extern void NSLinit(int,char**);
extern void NSLmain(int,char**);

extern NSL_DIFF DIFF; // differential class: EULER, etc.

extern nsl_matrix NSLexpdecay(nsl_matrix&,nsl_data&);
extern nsl_matrix KERNEL(int,int,nsl_data&,nsl_data&,nsl_data&);

// NSLstep
extern num_type NSLstep(num_type);
extern num_type NSLstep(num_type,num_type);
extern num_type NSLstep(num_type,num_type,num_type,num_type);
extern nsl_data NSLstep(nsl_data&);
extern nsl_data NSLstep(nsl_data&,nsl_data&);
extern nsl_data NSLstep(nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_vector NSLstep(nsl_vector&);
extern nsl_vector NSLstep(nsl_vector&,nsl_vector&);
extern nsl_vector NSLstep(nsl_vector&,nsl_data&);
extern nsl_vector NSLstep(nsl_vector&,nsl_vector&,nsl_vector&,nsl_vector&);
extern nsl_vector NSLstep(nsl_vector&,nsl_vector&,nsl_data&,nsl_data&);
extern nsl_vector NSLstep(nsl_vector&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_matrix NSLstep(nsl_matrix&);
extern nsl_matrix NSLstep(nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLstep(nsl_matrix&,nsl_data&);
extern nsl_matrix NSLstep(nsl_matrix&,nsl_matrix&,nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLstep(nsl_matrix&,nsl_matrix&,nsl_data&,nsl_data&);
extern nsl_matrix NSLstep(nsl_matrix&,nsl_data&,nsl_data&,nsl_data&);

// NSLramp
extern num_type NSLramp(num_type);
extern num_type NSLramp(num_type,num_type);
extern num_type NSLramp(num_type,num_type,num_type,num_type);
extern nsl_data NSLramp(nsl_data&);
extern nsl_data NSLramp(nsl_data&,nsl_data&);
extern nsl_data NSLramp(nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_vector NSLramp(nsl_vector&);
extern nsl_vector NSLramp(nsl_vector&,nsl_vector&);
extern nsl_vector NSLramp(nsl_vector&,nsl_data&);
extern nsl_vector NSLramp(nsl_vector&,nsl_vector&,nsl_vector&,nsl_vector&);
extern nsl_vector NSLramp(nsl_vector&,nsl_vector&,nsl_data&,nsl_data&);
extern nsl_vector NSLramp(nsl_vector&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_matrix NSLramp(nsl_matrix&);
extern nsl_matrix NSLramp(nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLramp(nsl_matrix&,nsl_data&);
extern nsl_matrix NSLramp(nsl_matrix&,nsl_matrix&,nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLramp(nsl_matrix&,nsl_matrix&,nsl_data&,nsl_data&);
extern nsl_matrix NSLramp(nsl_matrix&,nsl_data&,nsl_data&,nsl_data&);

// NSLsat
extern num_type NSLsat(num_type);
extern num_type NSLsat(num_type,num_type,num_type);
extern num_type NSLsat(num_type,num_type,num_type,num_type,num_type);
extern nsl_data NSLsat(nsl_data&);
extern nsl_data NSLsat(nsl_data&,nsl_data&,nsl_data&);
extern nsl_data NSLsat(nsl_data&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_vector NSLsat(nsl_vector&);
extern nsl_vector NSLsat(nsl_vector&,nsl_vector&,nsl_vector&);
extern nsl_vector NSLsat(nsl_vector&,nsl_data&,nsl_data&);
extern nsl_vector NSLsat(nsl_vector&,nsl_vector&,nsl_vector&,
				nsl_vector&,nsl_vector&);
extern nsl_vector NSLsat(nsl_vector&,nsl_vector&,nsl_vector&,nsl_data&,nsl_data&);
extern nsl_vector NSLsat(nsl_vector&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_matrix NSLsat(nsl_matrix&);
extern nsl_matrix NSLsat(nsl_matrix&,nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLsat(nsl_matrix&,nsl_data&,nsl_data&);
extern nsl_matrix NSLsat(nsl_matrix&,nsl_matrix&,nsl_matrix&,
				nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLsat(nsl_matrix&,nsl_matrix&,nsl_matrix&,nsl_data&,nsl_data&);
extern nsl_matrix NSLsat(nsl_matrix&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);

// NSLsigma
extern num_type NSLsigma(num_type);
extern num_type NSLsigma(num_type,num_type,num_type);
extern num_type NSLsigma(num_type,num_type,num_type,num_type,num_type);
extern nsl_data NSLsigma(nsl_data&);
extern nsl_data NSLsigma(nsl_data&,nsl_data&,nsl_data&);
extern nsl_data NSLsigma(nsl_data&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_vector NSLsigma(nsl_vector&);
extern nsl_vector NSLsigma(nsl_vector&,nsl_vector&,nsl_vector&);
extern nsl_vector NSLsigma(nsl_vector&,nsl_data&,nsl_data&);
extern nsl_vector NSLsigma(nsl_vector&,nsl_vector&,nsl_vector&,
				nsl_vector&,nsl_vector&);
extern nsl_vector NSLsigma(nsl_vector&,nsl_vector&,nsl_vector&,nsl_data&,nsl_data&);
extern nsl_vector NSLsigma(nsl_vector&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_matrix NSLsigma(nsl_matrix&);
extern nsl_matrix NSLsigma(nsl_matrix&,nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLsigma(nsl_matrix&,nsl_data&,nsl_data&);
extern nsl_matrix NSLsigma(nsl_matrix&,nsl_matrix&,nsl_matrix&,
				nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLsigma(nsl_matrix&,nsl_matrix&,nsl_matrix&,nsl_data&,nsl_data&);
extern nsl_matrix NSLsigma(nsl_matrix&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);

// NSLmax
extern num_type NSLmax(nsl_vector&);
extern num_type NSLmax(nsl_matrix&);
extern nsl_data NSLmax(nsl_data&,nsl_data&);
extern nsl_data NSLmax(nsl_data&,num_type);
extern nsl_vector NSLmax(nsl_vector&,nsl_vector&);
extern nsl_vector NSLmax(nsl_vector&,nsl_data&);
extern nsl_vector NSLmax(nsl_vector&,num_type);
extern nsl_matrix NSLmax(nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLmax(nsl_matrix&,nsl_data&);
extern nsl_matrix NSLmax(nsl_matrix&,num_type);

// NSLmin
extern num_type NSLmin(nsl_vector&);
extern num_type NSLmin(nsl_matrix&);
extern nsl_data NSLmin(nsl_data&,nsl_data&);
extern nsl_data NSLmin(nsl_data&,num_type);
extern nsl_vector NSLmin(nsl_vector&,nsl_vector&);
extern nsl_vector NSLmin(nsl_vector&,nsl_data&);
extern nsl_vector NSLmin(nsl_vector&,num_type);
extern nsl_matrix NSLmin(nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLmin(nsl_matrix&,nsl_data&);
extern nsl_matrix NSLmin(nsl_matrix&,num_type);

// vector and matrix transformations
extern nsl_vector NSLmat_to_vec(nsl_vector&,nsl_matrix&);
extern nsl_matrix NSLvec_to_mat(nsl_matrix&,nsl_vector&);

extern nsl_vector NSLmat_to_col_vec(nsl_vector&,nsl_matrix&);
extern nsl_vector NSLmat_to_row_vec(nsl_vector&,nsl_matrix&);
extern nsl_matrix NSLcol_vec_to_mat(nsl_matrix&,nsl_vector&);
extern nsl_matrix NSLrow_vec_to_mat(nsl_matrix&,nsl_vector&);

extern nsl_vector NSLmat_to_col_vec(nsl_matrix&);
extern nsl_vector NSLmat_to_row_vec(nsl_matrix&);
extern nsl_matrix NSLcol_vec_to_mat(nsl_vector&,int);
extern nsl_matrix NSLrow_vec_to_mat(nsl_vector&,int);

// NSLeuler
extern num_type NSLeuler(num_type,num_type,num_type);
extern nsl_data NSLeuler(nsl_data&,nsl_data&,nsl_data&);
extern nsl_data NSLeuler(nsl_data&,num_type,nsl_data&);
extern nsl_data NSLeuler(nsl_data&,nsl_data&,num_type);
extern nsl_data NSLeuler(nsl_data&,num_type,num_type);
extern nsl_vector NSLeuler(nsl_vector&,nsl_vector&,nsl_data&);
extern nsl_vector NSLeuler(nsl_vector&,nsl_vector&,num_type);
extern nsl_vector NSLeuler(nsl_vector&,nsl_data&,nsl_data&);
extern nsl_vector NSLeuler(nsl_vector&,nsl_data&,num_type);
extern nsl_vector NSLeuler(nsl_vector&,num_type,nsl_data&);
extern nsl_vector NSLeuler(nsl_vector&,num_type,num_type);
extern nsl_matrix NSLeuler(nsl_matrix&,nsl_matrix&,nsl_data&);
extern nsl_matrix NSLeuler(nsl_matrix&,nsl_matrix&,num_type);
extern nsl_matrix NSLeuler(nsl_matrix&,nsl_data&,nsl_data&);
extern nsl_matrix NSLeuler(nsl_matrix&,nsl_data&,num_type);
extern nsl_matrix NSLeuler(nsl_matrix&,num_type,nsl_data&);
extern nsl_matrix NSLeuler(nsl_matrix&,num_type,num_type);

// product
extern nsl_data NSLprod(nsl_vector&,nsl_vector&);
extern nsl_vector NSLprod(nsl_vector&,nsl_matrix&);
extern nsl_vector NSLprod(nsl_matrix&,nsl_vector&);
extern nsl_matrix NSLprod(nsl_matrix&,nsl_matrix&);

// convolution
extern nsl_vector NSLconv_zero(nsl_vector&,num_type);
extern nsl_vector NSLconv_zero(num_type,nsl_vector&);
extern nsl_vector NSLconv_zero(nsl_vector&,nsl_data&);
extern nsl_vector NSLconv_zero(nsl_data&,nsl_vector&);
extern nsl_vector NSLconv_zero(nsl_vector&,nsl_vector&);
extern nsl_vector NSLconv_wrap(nsl_vector&,nsl_vector&);
extern nsl_vector NSLconv_copy(nsl_vector&,nsl_vector&);

extern nsl_matrix NSLconv_zero(nsl_matrix&,num_type);
extern nsl_matrix NSLconv_zero(num_type,nsl_matrix&);
extern nsl_matrix NSLconv_zero(nsl_matrix&,nsl_data&);
extern nsl_matrix NSLconv_zero(nsl_data&,nsl_matrix&);
extern nsl_matrix NSLconv_zero(nsl_matrix&,nsl_vector&);
extern nsl_matrix NSLconv_zero(nsl_vector&,nsl_matrix&);
extern nsl_matrix NSLconv_zero(nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLconv_wrap(nsl_matrix&,nsl_matrix&);
extern nsl_matrix NSLconv_copy(nsl_matrix&,nsl_matrix&);
