//
// 	spatial_graph_3.h
//

struct spatial_graph_3 : public display_graph
{
	int hidden_fg;		// 1 - hidden line removal, 0 - otherwise
	float sx,sy,sz;		// scaling for 3D graphs 
	float ax,by,cz;		// rotation for 3D graphs
public:
		spatial_graph_3(display_window*);
	virtual	void	read_from_database();
	virtual	void	write_to_database();
	virtual void	print(ostream&);
	virtual void	display();
	virtual	void	input(int,int,int);
	virtual	void	output(int,int);
};

class spatial_graph_3_par : public spatial_graph_3
{
public:
		spatial_graph_3_par(display_window*,nsl_data*);
	void	read_from_database();
	void	write_to_database();

	void	display();
	void	print(ostream&);
};
class spatial_graph_3_vec : public spatial_graph_3
{
	int i0,i1;		// vecor range
	int imax;		// vector size
	int vec_type;		// 0 - row, 1 - col
public:
		spatial_graph_3_vec(display_window*,nsl_vector*);
	void	read_from_database();
	void	write_to_database();

	void	display();
	void	print(ostream&);
};
class spatial_graph_3_mat : public spatial_graph_3
{
	int i0,i1;		// row range
	int j0,j1;		// col range
	int imax,jmax;		// matrix size
public:
		spatial_graph_3_mat(display_window*,nsl_matrix*);
	void	read_from_database();
	void	write_to_database();

	void	display();
	void	print(ostream&);
};
