//
// 	temporal_graph.h
//

struct temporal_graph : public display_graph
{
	int pulsefg;
	float t0,t1;		// time range 
public:
		temporal_graph(display_window*);
	virtual	void	read_from_database();
	virtual	void	write_to_database();
	virtual void	print(ostream&);
	virtual void	display();
	virtual	void	input(int,int,int);
	virtual	void	output(int,int);
};

class temporal_graph_par : public temporal_graph
{
public:
		temporal_graph_par(display_window*,nsl_data*);
	void	read_from_database();
	void	write_to_database();
	void	display();
	void	print(ostream&);
};
class temporal_graph_vec : public temporal_graph
{
	int i0,i1;		// vector range
	int imax;		// vector size
	int vec_type; 		// 0 - row, 1 - col
public:
		temporal_graph_vec(display_window*,nsl_vector*);
	void	read_from_database();
	void	write_to_database();
	void	display();
	void	print(ostream&);
};
class temporal_graph_mat : public temporal_graph
{
	int i0,i1;		// row range
	int j0,j1;		// col range
	int imax,jmax;		// matrix size
public:
		temporal_graph_mat(display_window*,nsl_matrix*);
	void	read_from_database();
	void	write_to_database();
	void	display();
	void	print(ostream&);
};
