/****************************************************************/
/*                                                           	*/
/*                       nsl_main.c                          	*/
/*                                                            	*/
/* by Alfredo Weitzenfeld 					*/
/*                                                            	*/
/****************************************************************/

# include "nsl_include.h"
# include "bp_parms.h"

extern int nsl_get_str(istream&,char*);
extern void write_weights_cmd();
extern void read_weights_cmd();
extern void get_mask_cmd();
extern void init_mask_cmd();
extern void read_patterns_cmd();

int nsl_user_command(istream& in_file)
{
	int status = 1;
	string str1;

// use 'nsl_get_str' repeatedly for sequence of strings
	if (nsl_get_str(in_file,str1) != 0) 
	{
	  if (strcmp("write",str1) == 0)
	    {
	      write_weights_cmd();
	      return status;
	    }
	  if (strcmp("read",str1) == 0)
	    {
	      read_weights_cmd();
	      return status;
	    }
#ifdef LH_H_WEIGHT_MASK
	  if (strcmp("getmask",str1) == 0)
	    {
	      get_mask_cmd();
	      return status;
	    }
	  if (strcmp("initmask",str1) == 0)
	    {
	      init_mask_cmd();
	      return status;
	    }
#endif
	  if (strcmp("getpat",str1) == 0)
	    {
	      read_patterns_cmd();
	      return status;
	    }

	  cmd_error("Unknown User Command: ",str1);
	}
	else
		cmd_error("Cannot process 'user' command");

	return status;
}

main(int argc, char **argv)
{
  NSL_USER_CMD = nsl_user_command;

  NSLinit(argc,argv);

/* enter other code here */

#ifdef LH_H_WEIGHT_MASK
  init_mask_cmd();
#endif

	NSLmain(argc,argv);
}

