/****************************************************************/
/*                                                           	*/
/*                       convolution.c                          	*/
/*                                                            	*/
/****************************************************************/

# include "nsl_include.h"

NETWORK(CONVOLUTION);

MATRIX(S,10,10);	// network input 
MATRIX(u,10,10); 	// membrane potential
MATRIX(U,10,10); 	// firing rate

DATA(v); 	// membrane potential
DATA(V); 	// firing rate            // changed from VECTOR to DATA by dj
                                          // because no dimension specified for
                                          // them and compiler does not accept 
                                          // it.
DATA(k);
DATA(tu);
DATA(tv);
DATA(h1);
DATA(h2);
DATA(w1);
DATA(w2);

INIT_MODULE(convolution_init)
{
	u = 0;
	v = 0;
	U = 0;
	V = 0;
}

RUN_MODULE(convolution_U)
{
	DIFF.eq(u,tu) = - u + w1*U - w2*V - h1 + S; 
	U = NSLstep(u,k);
}
RUN_MODULE(convolution_V)
{
	DIFF.eq(v,tv) = - v + U.sum() - h2;
	V = NSLramp(v);
}














