/****************************************************************/
/*                                                           	*/
/*                       didday.c                          	*/
/*                                                            	*/
/****************************************************************/

# include "nsl_include.h"

NETWORK(DIDDAY);

VECTOR(S,10);	// network input 
VECTOR(u,10); 	// membrane potential
VECTOR(U,10); 	// firing rate

DATA(v); 	// membrane potential
DATA(V); 	// firing rate

DATA(k);
DATA(tu);
DATA(tv);
DATA(h1);
DATA(h2);
DATA(w1);
DATA(w2);

INIT_MODULE(didday_init)
{
	u = 0;
	v = 0;
	U = 0;
	V = 0;
}

RUN_MODULE(didday_U)
{
	DIFF.eq(u,tu) = - u + w1*U - w2*V - h1 + S; 
	U = NSLstep(u,k);
}
RUN_MODULE(didday_V)
{
	DIFF.eq(v,tv) = - v + U.sum() - h2;
	V = NSLramp(v);
}

