/****************************************************************/
/*                                                           	*/
/*                       limulus.c                          	*/
/*                                                            	*/
/****************************************************************/

# include "nsl_include.h"

NETWORK(LIMULUS);

VECTOR(E,4);
VECTOR(R1,4);
VECTOR(R2,4);

VECTOR(MASK,5);
DATA(tm);

INIT_MODULE(limulus_E_init)
{
	E = 0;
	E.elem(0) = 1;
	E.elem(1) = 1;
}
RUN_MODULE(limulus_E_run)
{
	float ts = LIMULUS.get_time();

	E.elem(0) = 1;
	E.elem(1) = 1;
	E.elem(2) = 0;

	if (ts >= 10.0 && ts <= 20.0)
		E.elem(3) = 1;
	else
		E.elem(3) = 0;
}
// recurrent inhibition
RUN_MODULE(limulus_R1_run)
{
	DIFF.eq(R1,tm) = -R1 + E - MASK * R1;
}
// non-recurrent inhibition
RUN_MODULE(limulus_R2_run)
{
	DIFF.eq(R2,tm) = -R2 + E - MASK * E;
}

