#!/bin/csh
###############################################################################
#if (! $?prompt) then
#  exit 0		# Not an interactive shell... exit
#endif

# if ld path does not exist set it to blank.  This is to prevent errors
# later on in the script
if (! $?LD_LIBRARY_PATH) then
	setenv LD_LIBRARY_PATH
endif

# if man path does not exist
if (! $?MANPATH) then
	setenv MANPATH
endif

alias disp 'setenv DISPLAY \!*\:0.0'

echo "Make sure your files end in .C "
echo "Make sure you read the user manual in"
echo "http://hbp.usc.edu/HBP/tools/NSL/home.html"

###############################################################################
# GENERIC NSL STUFF
# This assumes a sparc configuration
###############################################################################

set myos=(`uname -s`)
set myosver=(`uname -r`)
set myX11=(`printenv X11VERSION`)

if (! $?X11VERSION) then
	setenv X11VERSION "X11R5"
	echo "Setting X11VERSION to X11R5"
	echo "You can set it to something else using setenv"
	set myX11=(`printenv X11VERSION`)
endif

###############################################################################
#  MAIN IF
###############################################################################
# FOR SGI
##############################################################################
if ($myos == IRIX ) then
        echo $myos
        setenv LD_LIBRARY_PATH /usr/lib/:/usr/local/lib:$LD_LIBRARY_PATH 
        set path = ( /usr/local/bin $path)
###############################################################################
#For SUN 4.1.3
##############################################################################
else if (($myosver == 4.1.3_U1) && ($myX11 == X11R5)) then
	echo $myos
	setenv LD_LIBRARY_PATH /usr/usc/X/X11R5/lib:/usr/usc/X/lib:/usr/usc/X11:/usr/usc/X11/lib/:/usr/usc/openwin/lib/:/$LD_LIBRARY_PATH

	setenv MANPATH /usr/spac/sparcompilers/3.0.1/man:/usr/usc/openwin/man:/usr/local/man:/usr/usc/man:/usr/usc/X/man:/usr/spac/man:/usr/man:/usr/usc/tex/3.141/man:$MANPATH
###############################################################################

else if (($myosver == 4.1.3_U1) && ($myX11 == X11R4)) then
	#assume sunopenwindows window manager
	echo $myos
	setenv LD_LIBRARY_PATH /usr/usc/X/X11R4/lib:/usr/usc/X/lib:/usr/usc/X11:/usr/usc/openwin/lib:/usr/usc/X/openwin/lib:/usr/usc/openwin/lib:/usr/usc/X11/lib/:/usr/usc/openwin/lib/:$LD_LIBRARY_PATH

	setenv MANPATH /usr/spac/sparcompilers/3.0.1/man:/usr/usc/openwin/man:/usr/local/man:/usr/usc/man:/usr/usc/X/man:/usr/spac/man:/usr/man:/usr/usc/tex/3.141/man:$MANPATH

	set path = (/usr/usc/bin /usr/usc/X11/bin /usr/spac/sparcompilers/3.0.1/bin /usr/bin $path)

###############################################################################
#For SUN 5.3
###############################################################################

else if ($myosver == 5.3) then
	setenv LD_LIBRARY_PATH /usr/ucblib:/usr/ccs/lib
	setenv MANPATH /usr/spac/sparcompilers/default/SUNWspro/man:/usr/local/man:/usr/usc/man:/usr/usc/X/man:/usr/spac/man:/usr/man:/usr/usc/tex/3.141/man:$MANPATH
	set path = (/usr/ccs/bin /usr/usc/bin /usr/bin $path)
	#Xwindows motif
	if (($mywinman == mwm)||($mywinman == fwm)) then
		setenv LD_LIBRARY_PATH /usr/usc/X11/lib:/usr/usc/motif/default/lib:$LD_LIBRARY_PATH

		setenv MANPATH /usr/usc/motif/default/man:$MANPATH
		set path = (/usr/usc/X11/bin $path)
	else 
		#for Openwindows
		setenv LD_LIBRARY_PATH  /usr/usc/openwin/5.5/lib:/usr/usc/motif/default/lib:/usr/openwin/lib:$LD_LIBRARY_PATH
		setenv OPENWINHOME  /usr/usc/openwin/default
		setenv MANPATH /usr/openwin/man:$MANPATH
		set path = (/usr/usc/openwin/3.2/bin $path)
	endif
###############################################################################
#For SUN 5.4 or 5.5
###############################################################################

else if (($myosver == 5.4)||($myosver == 5.5)||($myosver == 5.5.1)) then
		setenv LD_LIBRARY_PATH /usr/ucblib:/usr/ccs/lib:/usr/usc/X11/lib:/usr/dt/lib:/usr/openwin/lib:$LD_LIBRARY_PATH
		setenv MANPATH /usr/dt/man:/usr/spac/sparcompilers/3.0.2/SUNWspro/man:/usr/local/man:/usr/usc/man:/usr/usc/X/man:/usr/spac/man:/usr/man:/usr/usc/tex/3.141/man:$MANPATH
		set path = (/usr/ccs/bin /usr/usc/bin /usr/usc/X11/bin /usr/bin $path)
#############################################################################
#For LINUX
############################################################################
else if ($myos == Linux) then
	echo $myos 

	setenv X11VERSION "X11R6"
	echo "Setting X11VERSION to X11R6"
	echo "You can set it to something else using setenv"
	set myX11=(`printenv X11VERSION`)
	setenv LD_LIBRARY_PATH /lib:/usr/X11R6/lib:/usr/X11R6/bin:/usr:/usr/lib/X11:/usr/lib/X11:/usr/openwin:/usr/openwin/bin/openwin:/usr/X11R6/bin/openwin:/usr/lib:$LD_LIBRARY_PATH 
	setenv MANPATH /usr/man:/usr/X11R6/bin/X 
        set path = (/usr/bin:/usr/X11R6/bin $path)        
endif 
###############################################################################

#if (-e /usr/spac/sparcompilers/default/setup.csh) then
#      source  /usr/spac/sparcompilers/default/setup.csh
#endif

###############################################################################
# NSL STUFF 
###############################################################################
setenv NSL21 ~nsl/NSL2.1.7
setenv NSL_DIR ~nsl/NSL2.1.7
set path = ($path $NSL21/bin)

## 96/11/3 aa - added env for sbrowser
setenv SUNPRO_SB_INIT_FILE_NAME $NSL_DIR/sb/.sbinit

## aliases
#limit core 0
alias ll 'ls -l'

## Adding the xview fonts to the server.
## fp+ /usr/openwin/fonts/100dpi
## fp+ /usr/openwin/fonts/75dpi











