//
// 	line_object.c
//

# include "nsl.h"
# include "nsl_headers.h"
# include "nsl_winds.h"

extern int draw_line(Canvas,int,int,int,int);
extern "C" void draw_broken_line(Canvas,int,int,int,int);

extern int draw_vertical_broken_line(Canvas,int,int,int);
extern int draw_horizontal_broken_line(Canvas,int,int,int);
extern int coord_transform(num_type,num_type,num_type,num_type,num_type);

// line object
line_object::line_object(display_window* window,float s0, float s1)
	: display_graph(window,"line")
{
	f0 = s0;
	f1 = s1;
	dir_type = 1;  // horizontal line
	line_type = 1; // broken line
}
line_object::~line_object()
{
}
void line_object::read_from_database()
{
	int vec_type;

	display_graph::read_from_database();

	if (parent_window->get_layer_type() == 2)
	{
	    parent_window->get_general_data("vec_type",&vec_type);
	    if (vec_type == 0)
		dir_type = 1; // horizontal
	    if (vec_type == 1)
		dir_type = 2; // vertical
	}
}
void line_object::write_to_database()
{
	display_graph::write_to_database();
}

void line_object::print(ostream& out)
{
	canvas_object::print(out);
}
void line_object::display()
{
//	draw_broken_line(canvas,x0,y0,x1,y1); // only one line

	int sx,wx;
	int sy,wy;

	if (able_fg == 0 || redraw_fg == 0)
		return;

	if (dir_type == 1) // horizontal, f0 = f1
	{
	  for (wy = wy0; wy <= wy1 - wys; wy = wy + wys)
	  {
      	    sy = coord_transform(f0,wymin,wymax,(float)wy,(float)wys);
	    if (sy > wy && sy < wy+wys)
//		if (line_type = 1) // broken 
		   draw_horizontal_broken_line(canvas,wx0,wx1,sy);
	  }
	}
	else if (dir_type == 2) // vertical, f0 = f1
	{
	  for (wx = wx0; wx <= wx1 - wxs; wx = wx + wxs)
	  {
  	    sx = coord_transform(f0,wymin,wymax,(float)wx,(float)wxs); 
	    if (sx > wx && sx < wx+wxs)
//		if (line_type = 1) // broken 
		   draw_vertical_broken_line(canvas,sx,wy0,wy1);
	  }
	}
	else
	  cmd_error("line_object::display: Unable to draw line");
}

