/**************************************************************/
/*                                                            */
/*                       nsl_command_help.c                   */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

//static char SccsId[] = "%W%  %G%"; /* SCCS */

# include "nsl_command.h"

extern void nsl_help_enable();
extern void nsl_help_disable();
extern void nsl_help_status();
extern void nsl_help_update();
extern void nsl_help_create();
extern void nsl_help_reset();
extern void nsl_help_set();
extern void nsl_help_set_network();
extern void nsl_help_set_module();
extern void nsl_help_set_layer();
extern void nsl_help_set_input();
extern void nsl_help_set_stim();
extern void nsl_help_set_frame();
extern void nsl_help_set_window();
extern void nsl_help_set_dump();
extern void nsl_help_set_file();
extern void nsl_help_exec();
extern void nsl_help_file();
extern void nsl_help_print();
extern void nsl_help_dump();
extern void nsl_help_proc();

void nsl_help()
{
	cout << "\nhelp 'command' ['command option']\n";
	cout << "\n";
	cout << "\nNSL command help\n\n";
	cout << "   command  \t      description\n";
	cout << "------------\t--------------------\n";
	cout << "\n";
	cout << "help\t\t- this command\n";
	cout << "create\t\t- create model objects\n";
	cout << "disable\t\t- disable objects\n";
	cout << "enable\t\t- enable objects\n";
	cout << "exec\t\t- execute a particular module\n";
	cout << "exit,quit\t- exit NSL\n";
	cout << "file\t\t- file info\n";
	cout << "\tfile_enable\t\t- enable layer for file in/out\n";
	cout << "\tfile_disable\t\t- disable layer for file in/out\n";
	cout << "\tclose\t\t- close a file\n";
	cout << "\tload,read\t- write a file\n";
	cout << "\topen\t- open a file\n";
	cout << "\twrite\t- write a file\n";
	cout << "print\t\t- printing commands\n";
	cout << "\tprint_dump\t- print a screen dump\n";
	cout << "\twin_dump\t- get a screen dump\n";
	cout << "proc\t\t- processing info\n";
	cout << "\tcont\t- process modules starting at current time\n";
	cout << "\tinit\t- process modules for t=0\n";
	cout << "\trun\t- process modules for t>=0\n";
	cout << "\tstep\t\t- process once through all modules\n";
	cout << "reset\t\t- reset object lists\n";
	cout << "set\t\t- set buffer variables\n";
	cout << "shell\t- shell command\n";
	cout << "\tcd\t- change model directory\n";
	cout << "\tcsh\t- execute a c-shell command\n";
	cout << "\tsh\t- execute a shell command\n";
	cout << "status\t\t- print status inforamtion on the model\n";
	cout << "update\t\t- update model objects\n";
	cout << "user\t\t- call a user defined command\n";
}
void nsl_help_help()
{
	cout << "help\t\t- print the available commands\n";
}
void nsl_help_quit()
{
	cout << "exit,quit\t- exit NSL\n";
}
void nsl_help_user()
{
	cout << "\nuser [user_cmd]\n";
	cout << "\t- call the specified user command\n";
}

void nsl_help_command(istream& in_file)
{
	string str1,str2;

	if (nsl_get_str(in_file,str1) == 0)
		nsl_help();
	else if (strcmp(str1,"help") == 0)
		nsl_help_help();
	else if (strcmp(str1,"create") == 0)
		nsl_help_create();
// enable,disable
	else if (strcmp(str1,"disable") == 0)
		nsl_help_disable();
	else if (strcmp(str1,"enable") == 0)
		nsl_help_enable();
// exec
	else if (strcmp(str1,"exec") == 0)
		nsl_help_exec();
// exit
	else if (strcmp(str1,"exit") == 0 || strcmp(str1,"quit") == 0)
		nsl_help_quit();
// file
	else if (strcmp(str1,"file") == 0)
		nsl_help_file();
	else if (strcmp(str1,"load") == 0 || strcmp(str1,"read") == 0)
		nsl_help_file();
	else if (strcmp(str1,"write") == 0)
		nsl_help_file();
	else if (strcmp(str1,"open") == 0)
		nsl_help_file();
	else if (strcmp(str1,"close") == 0)
		nsl_help_file();
// print
	else if (strcmp(str1,"print") == 0)
		nsl_help_dump();
	else if (strcmp(str1,"dump") == 0)
		nsl_help_dump();
	else if (strcmp(str1,"print_dump") == 0)
		nsl_help_dump();
	else if (strcmp(str1,"win_dump") == 0)
		nsl_help_dump();
// proc
	else if (strcmp(str1,"proc") == 0)
		nsl_help_proc();
	else if (strcmp(str1,"init") == 0)
		nsl_help_proc();
	else if (strcmp(str1,"run") == 0)
		nsl_help_proc();
	else if (strcmp(str1,"cont") == 0)
		nsl_help_proc();
	else if (strcmp(str1,"step") == 0)
		nsl_help_proc();
	else if (strcmp(str1,"reset") == 0)
		nsl_help_reset();
	else if (strcmp(str1,"set") == 0)
	{
	    if (nsl_get_str(in_file,str2) == 0)
		nsl_help_set();
	    else if (strcmp(str2,"network") == 0)
		nsl_help_set_network();
	    else if (strcmp(str2,"module") == 0)
		nsl_help_set_module();
	    else if (strcmp(str2,"layer") == 0)
		nsl_help_set_layer();
	    else if (strcmp(str2,"input_layer") == 0)
		nsl_help_set_input();
	    else if (strcmp(str2,"input_stim") == 0)
		nsl_help_set_stim();
	    else if (strcmp(str2,"display_frame") == 0)
		nsl_help_set_frame();
	    else if (strcmp(str2,"display_window") == 0)
		nsl_help_set_window();
/*	    else if (strcmp(str2,"rasterfile") == 0)
		nsl_help_set_dump();
	    else if (strcmp(str2,"datafile") == 0)
		nsl_help_set_file();
*/	    else
		nsl_help_set();
	}
// status
	else if (strcmp(str1,"status") == 0)
		nsl_help_status();
	else if (strcmp(str1,"update") == 0)
		nsl_help_update();
	else if (strcmp(str1,"user") == 0)
		nsl_help_user();
	else
		cmd_error("Unknown command: ",str1);

	cout << "\n";
	cout.flush();
}
