/**************************************************************/
/*                                                            */
/*              	 nsl_command_update.c                 */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

# include "nsl_command.h"

void update_model()
{
}

void update_input_layer()
{
	int ival;
	float fval;
	nsl_data* data;
	int type;

	if (NSL_INPUT_LAYER != NULL)
	{
	   type = NSL_INPUT_LAYER->get_layer_type();
	   switch (type)
	   {
	   case 1:
		break;
	   case 2:
		if ((data = CMD_BUF->get_data("input_xz")) != NULL)
		{
			ival = data->get_int_value();
			((nsl_input_vector*) NSL_INPUT_LAYER)->set_xz(ival);
		}
		if ((data = CMD_BUF->get_data("input_dx")) != NULL)
		{
			fval = data->get_float_value();
	   		((nsl_input_vector*) NSL_INPUT_LAYER)->set_dx(fval);
		}
		break;
	   case 3:
		if ((data = CMD_BUF->get_data("input_xz")) != NULL)
		{
			ival = data->get_int_value();
			((nsl_input_matrix*) NSL_INPUT_LAYER)->set_xz(ival);
		}
		if ((data = CMD_BUF->get_data("input_yz")) != NULL)
		{
			ival = data->get_int_value();
			((nsl_input_matrix*) NSL_INPUT_LAYER)->set_yz(ival);
		}
		if ((data = CMD_BUF->get_data("input_dx")) != NULL)
		{
			fval = data->get_float_value();
	   		((nsl_input_matrix*) NSL_INPUT_LAYER)->set_dx(fval);
		}
		if ((data = CMD_BUF->get_data("input_dy")) != NULL)
		{
			fval = data->get_float_value();
	   		((nsl_input_matrix*) NSL_INPUT_LAYER)->set_dy(fval);
		}
		break;
	    default:
		cmd_out("**** update input layer ****");
		cmd_out("Unknown type",type);

	    }
	}
}
void update_stim(nsl_stim_obj* stim)
{
	int ival;
	float fval;
	int type,spec;
	nsl_data* data;
	char* str;

	if (stim != NULL)
	{
//	   type = stim->get_type(); // ??
	   type = NSL_INPUT_LAYER->get_layer_type();
	   if ((data = CMD_BUF->get_data("stim_spec")) != NULL)
	   {
	   	str = data->get_str_value();
		if (strcmp(str,"CORNER") == 0)
		    spec = 1;
		else
		    spec = 0;
	   }
	   switch (type)
	   {
	   case 1:
		break;
	   case 2:
		if (spec == 0)
		{
		    if ((data = CMD_BUF->get_data("stim_xc")) != NULL)
		    {
			((nsl_stim_vector*) stim)->set_type(0);
			fval = data->get_float_value();
			((nsl_stim_vector*) stim)->set_xc(fval);
		    }
		}
		else
		{
		    if ((data = CMD_BUF->get_data("stim_x0")) != NULL)
		    {
		 	((nsl_stim_vector*) stim)->set_type(1);
			fval = data->get_float_value();
			((nsl_stim_vector*) stim)->set_x0(fval);
		    }
		}
		if ((data = CMD_BUF->get_data("stim_vx")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_stim_vector*) stim)->set_vx(fval);
		}
		break;
	   case 3:
		if (spec == 0)
		{
		    if ((data = CMD_BUF->get_data("stim_xc")) != NULL)
		    {
			((nsl_stim_matrix*) stim)->set_type(0);
			fval = data->get_float_value();
			((nsl_stim_matrix*) stim)->set_xc(fval);
		    }
		    if ((data = CMD_BUF->get_data("stim_yc")) != NULL)
		    {
			((nsl_stim_matrix*) stim)->set_type(0);
			fval = data->get_float_value();
			((nsl_stim_matrix*) stim)->set_yc(fval);
		    }
		}
		else
		{
		    if ((data = CMD_BUF->get_data("stim_x0")) != NULL)
		    {
			((nsl_stim_matrix*) stim)->set_type(1);
			fval = data->get_float_value();
			((nsl_stim_matrix*) stim)->set_x0(fval);
		    }
		    if ((data = CMD_BUF->get_data("stim_y0")) != NULL)
		    {
			((nsl_stim_matrix*) stim)->set_type(1);
			fval = data->get_float_value();
			((nsl_stim_matrix*) stim)->set_y0(fval);
		    }
		}
		if ((data = CMD_BUF->get_data("stim_vx")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_stim_matrix*) stim)->set_vx(fval);
		}
		if ((data = CMD_BUF->get_data("stim_vy")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_stim_matrix*) stim)->set_vy(fval);
		}
		break;
	   default:
		cmd_out("**** update stim ****");
		cmd_out("Unknown type",type);
	   }
	}
}
void update_block_stim(nsl_stim_obj* stim)
{
	int ival;
	float fval;
	int type;
	nsl_data* data;

	update_stim(stim);

	if (stim != NULL)
	{
//	   type = stim->get_type(); // ??
	   type = NSL_INPUT_LAYER->get_layer_type();
	   switch (type)
	   {
	   case 1:
		if ((data = CMD_BUF->get_data("stim_val")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_block_data*) stim)->set_val(fval);
		}
		break;
	   case 2:
		if ((data = CMD_BUF->get_data("stim_val")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_block_vector*) stim)->set_val(fval);
		}
		if ((data = CMD_BUF->get_data("stim_dx")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_block_vector*) stim)->set_dx(fval);
		}
		break;
	   case 3:
		if ((data = CMD_BUF->get_data("stim_val")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_block_matrix*) stim)->set_val(fval);
		}
		if ((data = CMD_BUF->get_data("stim_dx")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_block_matrix*) stim)->set_dx(fval);
		}
		if ((data = CMD_BUF->get_data("stim_dy")) != NULL)
		{
			fval = data->get_float_value();
			((nsl_block_matrix*) stim)->set_dy(fval);
		}
		break;
	   default:
		cmd_out("**** update block stim ****");
		cmd_out("Unknown type",type);
	   }
	}
}
void update_icon_stim(nsl_stim_obj* stim)
{
	update_stim(stim);
}
void update_time_interval(nsl_stim_obj* stim)
{
	nsl_time_obj* obj;
	float t0=0,t1=1;
	nsl_data* data;

	if (stim != NULL)
	{
	   if ((data = CMD_BUF->get_data("stim_t0")) != NULL)
		t0 = data->get_float_value();
	   if ((data = CMD_BUF->get_data("stim_t1")) != NULL)
		t1 = data->get_float_value();
	   if ((obj = stim->init_time_interval()) != NULL)
	   {
	    	stim->set_mode(1); // use time interval specifications
		obj->set_t0(t0);
		obj->set_t1(t1);
	   }
	}
}
void set_windows_size(display_frame* frame)
{
	int frame_rows=0;
	int frame_cols=0;
	int frame_width=0;
	int frame_height=0;
	nsl_data* data;

	if ((data = CMD_BUF->get_data("frame_rows")) != NULL)
	{
		frame_rows = data->get_int_value();
		if (frame_rows <= 0)
			frame_rows = 1;
		frame->set_window_rows(frame_rows);
	}
	if ((data = CMD_BUF->get_data("frame_cols")) != NULL)
	{
		frame_cols = data->get_int_value();
		if (frame_cols <= 0)
			frame_cols = 1;
		frame->set_window_cols(frame_cols);
	}

	if ((data = CMD_BUF->get_data("frame_width")) != NULL)
		frame_width = data->get_int_value();
	if ((data = CMD_BUF->get_data("frame_height")) != NULL)
		frame_height = data->get_int_value();

	if (frame_rows > 0 && frame_cols > 0)
	{
	    int hoff = (frame_height)%frame_rows;
	    int window_height = (frame_height - hoff)/frame_rows;

	    int woff = frame_width%frame_cols;
	    int window_width = (frame_width - woff)/frame_cols;

	    if ((data = CMD_BUF->get_data("window_width")) != NULL)
		data->set_value((int) window_width);
	    if ((data = CMD_BUF->get_data("window_height")) != NULL)
		data->set_value((int) window_height);
	}
	else
	    cmd_error("nsl_command_update.c:Cannot set window size");
}
void update_display_frame(display_frame* frame,int flag)
{
	int X0,Y0,width,height;
	nsl_data* data;

 	if (flag == 1)
	{
		frame->reset();		// reset frame window lists
		frame->init();		// init frame data (dummy)
	}

 	if ((data = CMD_BUF->get_data("frame_X0")) != NULL)
		X0 = data->get_int_value();

 	if ((data = CMD_BUF->get_data("frame_Y0")) != NULL)
		Y0 = data->get_int_value();

 	if ((data = CMD_BUF->get_data("frame_width")) != NULL)
		width = data->get_int_value();

 	if ((data = CMD_BUF->get_data("frame_height")) != NULL)
		height = data->get_int_value();

	set_windows_size(frame);

 	if ((data = CMD_BUF->get_data("frame_auto_resize")) != NULL)
	{
	    if (strcmp(data->get_str_value(),"ON") == 0)
		frame->set_resize_fg(1);
	    else
		frame->set_resize_fg(0);
	}

  	if (flag == 1)
    	    frame->create(X0,Y0,width,height);
	else
    	    frame->resize(X0,Y0,width,height);

	frame->update();		// update frame windows data
}
void set_auto_window_location(display_window* window)
{
	if (DEBUG_FG == 1)
	{
		cout << "// set_auto_window_location(" << window->get_name();
		cout << ");\n";
		cout.flush();
	}

	nsl_data* data;
	int window_X0,window_Y0,window_width,window_height;
	int frame_rows,frame_cols;

	int index = window->get_index();

	if ((data = CMD_BUF->get_data("frame_rows")) != NULL)
	    frame_rows = data->get_int_value();
	if ((data = CMD_BUF->get_data("frame_cols")) != NULL)
	    frame_cols = data->get_int_value();

	if (frame_rows > 0 && frame_cols > 0)
	{
	    if ((data = CMD_BUF->get_data("window_width")) != NULL)
	    	window_width = data->get_int_value();
	    if ((data = CMD_BUF->get_data("window_height")) != NULL)
	    	window_height = data->get_int_value();

    	    window_X0 = (window_width)*((index-1)%frame_cols);
    	    window_Y0 = (window_height)*((index-1)/frame_cols);

	    if ((data = CMD_BUF->get_data("window_X0")) != NULL)
	    	data->set_value((int) window_X0);
	    if ((data = CMD_BUF->get_data("window_Y0")) != NULL)
	    	data->set_value((int) window_Y0);
	}
}
void update_display_window(display_window* window,int flag)
{
	if (DEBUG_FG == 1)
	{
		cout << "// update_display_window(" << window->get_name();
		cout << "," << flag << ");\n";
		cout.flush();
	}

	char *str,*sval,*tmp;
	nsl_data* data;
	int ival;
	float fval;
	int X0,Y0,width,height;
	nsl_layer* layer;
	int reset_data_fg = 0;

// create (flag = 1) or resize (flag = 0) window
	if ((data = CMD_BUF->get_data("frame_auto_resize")) != NULL)
	{
	    if (strcmp(data->get_str_value(),"ON") == 0)
		set_auto_window_location(window);
	}

	if ((data = CMD_BUF->get_data("window_X0")) != NULL)
	{
	    X0 = data->get_int_value();
	    window->set_X0(X0);
	}

	if ((data = CMD_BUF->get_data("window_Y0")) != NULL)
	{
	    Y0 = data->get_int_value();
	    window->set_Y0(Y0);
	}

 	if ((data = CMD_BUF->get_data("window_width")) != NULL)
	{
	    width = data->get_int_value();
	    window->set_width(width);
	}

 	if ((data = CMD_BUF->get_data("window_height")) != NULL)
	{
	    height = data->get_int_value();
	    window->set_height(height);
	}

	if (flag == 1)
	    window->create(X0,Y0,width,height);
	else
    	    window->resize(X0,Y0,width,height);

// set window (main) data
 	if ((data = CMD_BUF->get_data("window_layer")) != NULL)
	{
	    str = data->get_str_value();
	    tmp = window->get_layer_name();
	    if (strcmp(tmp,str) != 0)
	    {
//	        CMD_BUF->update_layer_buffer(str);
		window->update_window_layer(str);
		reset_data_fg = 1;
	    }
	}

 	if ((data = CMD_BUF->get_data("window_graph")) != NULL)
	{
	    str = data->get_str_value();
	    tmp = window->get_graph_name();
	    if (strcmp(tmp,str) != 0)
	    {
//	        CMD_BUF->update_graph_buffer(str);
		window->update_window_graph(str);
		reset_data_fg = 1;
	    }
	}

	if (reset_data_fg == 1)
	{
		window->reset_data();
		window->init_data();
	}

	if ((layer = window->get_layer()) != NULL)
	{
		int type = layer->get_layer_type();
		switch (type)
		{
		case 1:
		   break;
 		case 2:
		   if ((data = CMD_BUF->get_data("window_layer_i0")) != NULL)
		   {
			ival = data->get_int_value();
			window->set_general_data("i0",ival);
		   }
 		   if ((data = CMD_BUF->get_data("window_layer_i1")) != NULL)
		   {
			ival = data->get_int_value();
			window->set_general_data("i1",ival);
		   }
	    	   if ((data = CMD_BUF->get_data("window_vec_type")) != NULL)
	   	   {
			str = data->get_str_value();
			if (strcmp(str,"VERTICAL") == 0)
				ival = 1;
			else
				ival = 0;
			window->set_general_data("vec_type",ival);
	   	   }
 		   break;
		case 3:
		   if ((data = CMD_BUF->get_data("window_layer_i0")) != NULL)
		   {
			ival = data->get_int_value();
			window->set_general_data("i0",ival);
		   }
 		   if ((data = CMD_BUF->get_data("window_layer_i1")) != NULL)
		   {
			ival = data->get_int_value();
			window->set_general_data("i1",ival);
		   }
 		   if ((data = CMD_BUF->get_data("window_layer_j0")) != NULL)
		   {
			ival = data->get_int_value();
			window->set_general_data("j0",ival);
		   }
 		   if ((data = CMD_BUF->get_data("window_layer_j1")) != NULL)
		   {
			ival = data->get_int_value();
			window->set_general_data("j1",ival);
		   }
		   break;
		default:
		   cmd_error("nsl_command_update.c:Unknown layer type: ",type);
		}
	}
	else
	{
		cmd_error("nsl_command_update.c:*** init_display_window ***");
		cmd_error("nsl_command_update.c:NULL layer");
	}

	if ((data = CMD_BUF->get_data("window_wymin")) != NULL)
	{
		fval = data->get_float_value();
		window->set_general_data("wymin",fval);
	}
 	if ((data = CMD_BUF->get_data("window_wymax")) != NULL)
	{
		fval = data->get_float_value();
		window->set_general_data("wymax",fval);
	}


	int graph_type = window->get_graph_type();

	switch (graph_type)
	{
	    case 1: // area_level_graph
 	    	if ((data = CMD_BUF->get_data("window_val_in")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("val_in",fval);
	   	}
		break;
	    case 2: // spatial_graph_2
 	    	if ((data = CMD_BUF->get_data("window_pulse")) != NULL)
	    	{
			sval = data->get_str_value();
			window->set_general_data("pulsefg",sval);
	   	}
		break;
	    case 3: // spatial_graph_3
 	    	if ((data = CMD_BUF->get_data("window_hidden_line")) != NULL)
	    	{
			sval = data->get_str_value();
			window->set_general_data("hiddenfg",sval);
	    	}
 	   	if ((data = CMD_BUF->get_data("window_ax")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("ax",fval);
	   	 }
 	    	if ((data = CMD_BUF->get_data("window_by")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("by",fval);
	    	}
 	    	if ((data = CMD_BUF->get_data("window_cz")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("cz",fval);
	    	}
 	    	if ((data = CMD_BUF->get_data("window_sx")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("sx",fval);
	    	}
 	    	if ((data = CMD_BUF->get_data("window_sy")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("sy",fval);
	    	}
 	    	if ((data = CMD_BUF->get_data("window_sz")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("sz",fval);
	    	}
		break;
	    case 4: // temporal_graph
 	    	if ((data = CMD_BUF->get_data("window_t0")) != NULL)
	   	{
			fval = data->get_float_value();
			window->set_general_data("t0",fval);
	        }
 	    	if ((data = CMD_BUF->get_data("window_t1")) != NULL)
	    	{
			fval = data->get_float_value();
			window->set_general_data("t1",fval);
		}
	 	if ((data = CMD_BUF->get_data("window_pulse")) != NULL)
	    	{
			sval = data->get_str_value();
			window->set_general_data("pulsefg",sval);
	   	}
		break;
	    case 5: // user_graph
		break;
	    default: 
		cmd_error("nsl_command_update.c:Unknown graph_type: ",graph_type);
	}
	
	if ((data = CMD_BUF->get_data("window_step")) != NULL)
	{
		ival = data->get_int_value();
		window->set_general_data("window_step",ival);
	}

	if ((data = CMD_BUF->get_data("window_overlay")) != NULL)
	{
	    sval = data->get_str_value();
	    window->set_general_data("window_overlay",sval);
	}

        if (reset_data_fg == 1)
	{
	    display_canvas* canvas;
	    if ((canvas = window->get_window_canvas()) != NULL)
	    {
		canvas->reset();
		canvas->init();
		canvas->update();
//		canvas->clear();
	    }
	    else
		cmd_error("nsl_command_update.c:Cannot init window canvas");

	    display_panel* panel;
	    if ((panel = window->get_control_panel()) != NULL)
	    {
		panel->reset_data();
		panel->init_data();
		panel->update();
	    }
	    else
		cmd_error("nsl_command_update.c:Cannot init data panel");
	}
}
void update_display_canvas(display_window* window)
{
	if (DEBUG_FG == 1)
	{
		cout << "// update_display_canvas(" << window->get_name();
		cout << ");\n";
		cout.flush();
	}

	display_canvas* canvas;

	if ((canvas = window->get_window_canvas()) != NULL)
	{
/*		canvas->reset();
		canvas->init();
*/		canvas->update();
	}
	else
		cmd_error("nsl_command_update.c:Cannot init window canvas");
}
void update_display_panel(display_window* window)
{
	if (DEBUG_FG == 1)
	{
		cout << "// update_display_panel(" << window->get_name();
		cout << ");\n";
		cout.flush();
	}

	display_panel* panel;
	if ((panel = window->get_control_panel()) != NULL)
	{
//		panel->init();
		panel->update();
	}
	else
		cmd_error("nsl_command_update.c:Cannot init data panel");
}
void update_canvas_item(canvas_object* item)
{
	if (DEBUG_FG == 1)
	{
		cout << "// update_canvas_item(" << item->get_index();
		cout << ");\n";
		cout.flush();
	}

	nsl_data* data;
	int ival,index;

 	if ((data = CMD_BUF->get_data("canvas_item_enable")) != NULL)
	{
	    if ((ival = nsl_get_on_off(data)) == 0)
		item->disable();
	    else
		item->enable();
	}
 	if ((data = CMD_BUF->get_data("canvas_item_wx")) != NULL)
	{
		ival = data->get_int_value();
		item->set_wx(ival);
	}
 	if ((data = CMD_BUF->get_data("canvas_item_wy")) != NULL)
	{
		ival = data->get_int_value();
		item->set_wy(ival);
	}
}
void update_canvas_item(display_canvas* canvas,int index)
{
	canvas_object* item;

	if (index <= 0)
		cmd_error("nsl_command_update.c:Bad canvas item index: ",index); 
	else if ((item = canvas->get_canvas_item(index)) != NULL)
		update_canvas_item(item);
	else
		cmd_error("nsl_command_update.c:Cannot get canvas item index: ",index); 
}
void update_canvas_item(display_canvas* canvas,char* str)
{
	canvas_object* item;

	if ((item = canvas->get_canvas_item(str)) != NULL)
		update_canvas_item(item);
	else
		cmd_error("nsl_command_update.c:Cannot get canvas item: ",str); 
}
void update_all_canvas_item(display_canvas* canvas)
{
	canvas_type_list* canvas_items = canvas->get_graph_objects();

	if (canvas_items != NULL)
	{
	    canvas_type_iterator next(*canvas_items);
	    canvas_object* item;
	    while (item = next()) 
		update_canvas_item(item);
	}
}
/*
void update_canvas_item(display_window* window)
{
	if (DEBUG_FG == 1)
	{
		cout << "// update_canvas_item(" << window->get_name();
		cout << ");\n";
		cout.flush();
	}

	display_canvas* canvas;
	canvas_object* item;
	nsl_data* data;
	int ival,index;

	if ((canvas = window->get_window_canvas()) != NULL)
	{
	    if ((data = CMD_BUF->get_data("canvas_item_index")) != NULL)
	    {
	        index = data->get_int_value();
	        if (index <= 0)
		    cmd_error("nsl_command_update.c:Bad canvas item index: ",index); 
	        else if ((item = canvas->get_canvas_item(index)) != NULL)
		{
 		    if ((data = CMD_BUF->get_data("canvas_item_enable")) != NULL)
	            {
			if ((ival = nsl_get_on_off(data)) == 0)
			   item->disable();
			else
			   item->enable();
		    }
 		    if ((data = CMD_BUF->get_data("canvas_item_wx")) != NULL)
	            {
			ival = data->get_int_value();
			item->set_wx(ival);
		    }
 		    if ((data = CMD_BUF->get_data("canvas_item_wy")) != NULL)
	            {
			ival = data->get_int_value();
			item->set_wy(ival);
		    }
		}
		else
		    cmd_error("nsl_command_update.c:// Cannot open canvas");
	    }
	}
	else
		cmd_error("nsl_command_update.c:Cannot init window canvas");
}
*/
void update_panel_item(display_window* window)
{
	if (DEBUG_FG == 1)
	{
		cout << "// update_panel_item(" << window->get_name();
		cout << ");\n";
		cout.flush();
	}

	display_panel* panel;
	panel_object* item;
	nsl_data* data;
	int ival,index;

	if ((panel = window->get_control_panel()) != NULL)
	{
	    if ((data = CMD_BUF->get_data("panel_item_index")) != NULL)
	    {
	        index = data->get_int_value();
	        if (index <= 0)
		    cmd_error("nsl_command_update.c:Bad panel item index: ",index); 
	        else if ((item = panel->get_panel_item(index)) != NULL)
		{
 		    if ((data = CMD_BUF->get_data("panel_item_enable")) != NULL)
	            {
			if ((ival = nsl_get_on_off(data)) == 0)
			   item->disable();
			else
			   item->enable();
		    }
 		    if ((data = CMD_BUF->get_data("panel_item_wx")) != NULL)
	            {
			ival = data->get_int_value();
			item->set_wx(ival);
		    }
 		    if ((data = CMD_BUF->get_data("panel_item_wy")) != NULL)
	            {
			ival = data->get_int_value();
			item->set_wy(ival);
		    }
		}
		else
		    cmd_error("nsl_command_update.c:// Cannot open panel");
	    }
	}
	else
		cmd_error("nsl_command_update.c:Cannot init data panel");
}

void nsl_help_update()
{
	cout << "\nupdate 'type'\n";
	cout << "\n";
	cout << "update buffer info to objects\n";
	cout << "\n";
	cout << "    type    \t\t   description\n";
	cout << "------------\t\t-------------------\n";
	cout << "\n";
	cout << "block_stim\t\tupdate existing block stimulus\n";
	cout << "icon_stim\t\tupdate existing icon stimulus\n";
	cout << "time_stim\t\tupdate existing stimulus time interval\n";
	cout << "window_interface\tupdate all frames and windows\n";
	cout << "display_frame\t\tupdate display frames\n";
	cout << "display_window\t\tupdate display window\n";
	cout << "display_canvas\t\tupdate display canvas\n";
	cout << "display_panel\t\tupdate display panel\n";
	cout << "canvas_item\t\tupdate canvas item\n";
	cout << "panel_item\t\tupdate panel item\n";
}

int nsl_update_command(istream& in_file)
{
	if (DEBUG_FG == 1)
	{
		cout << "// nsl_update_command(in);\n";
		cout.flush();
	}

	int status = 1,index;
	string str,str1,str2;
	display_frame* frame;
	display_window* window;

	if (nsl_get_str(in_file,str1) == 0)
	{
		nsl_help_update();
		return 1;
	}

	set_global_pointers();

	if (strcmp(str1,"block_stim") == 0)
	{
/*	    if (NSL_INPUT_LAYER != NULL)
	    {
		if ((input_stim = update_block_stim(NSL_INPUT_LAYER)) != NULL)
		   NSL_INPUT_STIM = input_stim;
		else
		   cmd_error("nsl_command_update.c:NULL input stim");
    	    }
	    else
		cmd_error("nsl_command_update.c:NULL input layer");
*/	}
	else if (strcmp(str1,"icon_stim") == 0)
	{
/*	    if (NSL_INPUT_LAYER != NULL)
	    {
		if ((input_stim = update_icon_stim(NSL_INPUT_LAYER)) != NULL)
		   NSL_INPUT_STIM = input_stim;
		else
		   cmd_error("nsl_command_update.c:NULL input stim");
    	    }
	    else
		cmd_error("nsl_command_update.c:NULL input layer");
*/	}
	else if (strcmp(str1,"time_stim") == 0)
	{
/*	    if (NSL_INPUT_STIM != NULL)
	    {
		update_time_stim(NSL_INPUT_STIM);
    	    }
	    else
		cmd_error("nsl_command_update.c:NULL input stim");
*/	}
	else if (NSL_INTERFACE == NULL)
	{
		cmd_error("nsl_command_update.c:NULL window interface");
		return -1;
	}
	else if (strcmp(str1,"window_interface") == 0)
	{
	        NSL_INTERFACE->update();
	}
	else if (strcmp(str1,"display_frame") == 0)
	{
	    CMD_BUF->get_general_data("frame_name",str);
	    if ((frame = NSL_INTERFACE->get_display_frame(str)) != NULL)
	    {
		NSL_FRAME = frame;
	    	update_display_frame(frame,0);
	    }
	    else
		cmd_error("nsl_command_update.c:Cannot open display_frame ",str);
	}
	else if (strcmp(str1,"display_window") == 0) // update to window
	{
	    CMD_BUF->get_general_data("window_name",str);
	    if ((window = NSL_INTERFACE->get_display_window(str)) != NULL)
	    {
		NSL_WINDOW = window;
	    	update_display_window(window,0);
		NSL_CANVAS = window->get_window_canvas();
		NSL_PANEL = window->get_control_panel();
	    }
	    else
		cmd_error("nsl_command_update.c:Unknown display_window: ",str);
	}
	else if (strcmp(str1,"display_canvas") == 0) // update canvas
	{
		if (NSL_WINDOW != NULL)
			update_display_canvas(NSL_WINDOW);
		else
		 	cmd_error("nsl_command_update.c:Unknown display_window");
	}
	else if (strcmp(str1,"display_panel") == 0) // update panel
	{
		if (NSL_WINDOW != NULL)
			update_display_panel(NSL_WINDOW); 
		else
			cmd_error("nsl_command_update.c:Unknown display_window");
	}
	else if (strcmp(str1,"canvas_item") == 0) // update canvas
	{
	    if (NSL_CANVAS != NULL)
	    {
	        if (nsl_get_str(in_file,str2) == 0)
		{
		   if (NSL_CANVAS_ITEM != NULL)
			update_canvas_item(NSL_CANVAS_ITEM); 
		   else
			cmd_error("nsl_command_update.c:NULL NSL_CANVAS_ITEM");
		}
		else if ((index = atoi(str2)) != 0)
		   update_canvas_item(NSL_CANVAS,index);
	        else if (strcmp("ALL",str2) == 0)
		   update_all_canvas_item(NSL_CANVAS);
	        else
		   update_canvas_item(NSL_CANVAS,str2);
	    }
	    else
		cmd_error("nsl_command_update.c:NULL NSL_CANVAS");
	}
	else if (strcmp(str1,"panel_item") == 0) // update canvas
	{
		if (NSL_WINDOW != NULL)
			update_panel_item(NSL_WINDOW); 
	}
	else
		cmd_error("nsl_command_update.c:Unknown Modifier: ",str1);

	return status;
}
