//
//	nsl_module.c
//

# include "nsl.h"
# include "nsl_headers.h"

extern nsl_model* NSL_MODEL;
nsl_module* NSL_MODULE;

nsl_module::nsl_module(nsl_model* model,char* str,void (*f)())
{
	strcpy(name,str);
	able_fg = 1;
	time_fg = 0;

	if (f != NULL)
		mod_func = f;
	else
		cmd_error_exit("Unknown *** nsl_module *** function");

	model->add_module(this);
}
nsl_module::nsl_module(nsl_model& model,char* str,void (*f)())
{
	strcpy(name,str);
	able_fg = 1;
	time_fg = 0;

	if (f != NULL)
		mod_func = f;
	else
		cmd_error_exit("Unknown *** nsl_module *** function");

	model.add_module(this);
}
nsl_module::nsl_module(nsl_model* model,char* str,void (*f)(),int tfg)
{
	strcpy(name,str);
	able_fg = 1;
	time_fg = tfg;

	if (f != NULL)
		mod_func = f;
	else
		cmd_error_exit("Unknown *** nsl_module *** function");

	model->add_module(this);
}
nsl_module::nsl_module(nsl_model& model,char* str,void (*f)(),int tfg)
{
	strcpy(name,str);
	able_fg = 1;
	time_fg = tfg;

	if (f != NULL)
		mod_func = f;
	else
		cmd_error_exit("Unknown *** nsl_module *** function");

	model.add_module(this);
}

nsl_module::nsl_module(char* str,void (*f)())
{
	strcpy(name,str);
	able_fg = 1;
	time_fg = 0;

	if (f != NULL)
		mod_func = f;
	else
		cmd_error_exit("Unknown *** nsl_module *** function");

	NSL_MODEL->add_module(this);
}
nsl_module::nsl_module(char* str,void (*f)(),int tfg)
{
	strcpy(name,str);

	if (tfg == -1)
	{
		able_fg = 0;
	}
	else
	{
		able_fg = 1;
	}
	time_fg = tfg;

	if (f != NULL)
		mod_func = f;
	else
		cmd_error_exit("Unknown *** nsl_module *** function");

	NSL_MODEL->add_module(this);
}
nsl_module::~nsl_module()
{
}

void nsl_module::exec()
{
	if (verbose_fg == 1)
		cmd_out("// executing module: ",get_name());
	mod_func();
}
void nsl_module::proc(float time)
{
	if (able_fg == 1)
	{
	    switch (time_fg)
	    {
	    case 1:
		if (time == 0)
		{
		   if (verbose_fg == 1)
			cmd_out("// processing module: ",get_name());
		   mod_func();
		}
		break;
	    case 2: 
		if (time > 0)
		{
		   if (verbose_fg == 1)
			cmd_out("// processing module: ",get_name());
		   mod_func();
		}
		break;
	    default: // 0
		if (verbose_fg == 1)
		   cmd_out("// processing module: ",get_name());
		mod_func();
	    }
	}
}

// print model status info to 'out' stream

void nsl_module::print_status(ostream& out)
{
	out << "\n";
	out << "// " << index << ": " << name << "\n";
	if (time_fg == 2)
	   out << "// RUN_MODULE, processing for t > 0\n";
	else if (time_fg == 1)
	   out << "// INIT_MODULE, processing for t = 0\n";
	else // if (time_fg == 0)
	   out << "// MODULE, processing for t >= 0\n";
	out << "set module " << name << "\n";
	if (able_fg == 1)
	   out << "enable module\n";
	else // if (able_fg == 0)
	   out << "disable module\n";
/*	if (able_fg == 1)
	   out << "set able_fg ON\n";
	else // if (able_fg == 0)
	   out << "set able_fg OFF\n";
*/	if (verbose_fg == 1)
	   out << "set verbose_fg ON\n";
	else // if (verbose_fg == 0)
	   out << "set verbose_fg OFF\n";
/*	if (mod_func != NULL)
	   out << "// module function: " << mod_func << "\n";
	else // if (mod_func == NULL)
	   out << "// mod_func: " << "NULL\n";
*/	out.flush();
}

