//
//	nsl_stim_obj.c
//

# include "nsl.h"
# include "nsl_headers.h"

// nsl_time_obj

nsl_time_obj::nsl_time_obj()
{
	stim_obj = 0;

	able_fg = 1;
	type = 1;
}
nsl_time_obj::nsl_time_obj(nsl_stim_obj* obj)
{
	stim_obj = obj;

	able_fg = 1;
	type = 1;
}
nsl_time_obj::~nsl_time_obj()
{
}
void nsl_time_obj::print(ostream& out)
{
	out << "set index " << index << "\n";
	if (able_fg == 1) 
	   out << "enable time_interval\n";
	else // if (able_fg == 0)
	   out << "disable time_interval\n";
	if (type == 1) 
	   out << "set time_slots ON\n";
	else // if (type == 0)
	   out << "set time_slots OFF\n";
	out << "set time_t0 " << t0 << "\n";
	out << "set time_t1 " << t1 << "\n";

	out << "create time_interval\n"; // time_obj
	out.flush();
}
void nsl_time_obj::print_stim(ostream& out)
{
	print(out); // not needed
}

// nsl_stim_obj

nsl_stim_obj::nsl_stim_obj()
{
	time_total = 0;
	time_list = new nsl_time_list;

	able_fg = 1;
	add_fg = 0;

	mode = 0;

	step = 1;
}
nsl_stim_obj::~nsl_stim_obj()
{
}

nsl_time_obj* nsl_stim_obj::init_time_interval()
{
	nsl_time_obj* obj;

	if ((obj = new nsl_time_obj(this)) != NULL)
	{
		obj->set_index(++time_total);
		time_list->append(obj);
	}
	else
	{
		cmd_error("*** nsl_stim_obj::init_time_interval ***");
		cmd_error("Unable to create new time interval");
	}

	return obj;
}

void nsl_stim_obj::proc()
{
}

void nsl_stim_obj::run()
{
}

void nsl_stim_obj::print_time(ostream& out)
{
	out << "\n// time_total: " << time_total << "\n";
	out.flush();

	nsl_time_iterator next(*time_list);
	nsl_time_obj* time_obj;
	while (time_obj = next())
	   time_obj->print(out);
}
void nsl_stim_obj::print(ostream& out)
{
	out << "\nset stim_index " << index << "\n";
	if (able_fg == 1) 
	   out << "enable input_stim\n";
	else // if (able_fg == 0)
	   out << "disable input_stim\n";
	if (add_fg == 1) 
	   out << "set stim_overlap ON\n";
	else // if (add_fg == 0)
	   out << "set stim_overlap OFF\n";
	if (mode == 1) 
	   out << "set stim_intervals ON\n";
	else // if (mode == 0)
	   out << "set stim_intervals OFF\n";
	out << "set stim_recalc " << step << "\n";

	out << "create stim_obj\n";

	print_time(out);
}
void nsl_stim_obj::print_stim(ostream& out)
{
	print(out);
}
