//
//	spatial_graph_2.c
//

# include "nsl.h"
# include "nsl_headers.h"
# include "nsl_winds.h"

extern void draw_spatial_graph_2_par(Canvas,num_type,
	int,int,int,int,int,int,num_type,num_type,int);
extern void draw_spatial_graph_2_vector(Canvas,num_type*,
	int,int,int,int,int,int,int,int,num_type,num_type,int,int);

extern void set_menu_canvas_events(Canvas);

spatial_graph_2::spatial_graph_2(display_window* window)
	: display_graph(window,"spatial_graph_2")
{
	set_menu_canvas_events(canvas);
	parent_canvas->set_clear_fg(1);
}
void spatial_graph_2::read_from_database()
{
	string str;

	display_graph::read_from_database();
	parent_window->get_general_data("pulsefg",str);

	if (strcmp(str,"ON") == 0)
		pulsefg = 1;
	else
		pulsefg = 0;
}
void spatial_graph_2::write_to_database()
{
	display_graph::write_to_database();
}
void spatial_graph_2::input(int x_pos,int y_pos,int fg)
{
}
void spatial_graph_2::output(int x_pos,int y_pos)
{
}
void spatial_graph_2::display()
{
}
void spatial_graph_2::print(ostream& out)
{
	canvas_object::print(out);
}

// par
spatial_graph_2_par::spatial_graph_2_par(display_window* window,
	nsl_data* m) : spatial_graph_2(window)
{
	layer_ptr = m;
	layer0_ptr = m;
}
void spatial_graph_2_par::read_from_database()
{
	parent_window->set_win_sector(0,0,0,0,1,1); // update win sector
	spatial_graph_2::read_from_database(); // read in new win sector
}
void spatial_graph_2_par::write_to_database()
{
	spatial_graph_2::write_to_database();
}
void spatial_graph_2_par::display()
{
	num_type m = ((nsl_data*) layer0_ptr)->get_data();

	draw_spatial_graph_2_par(canvas,m,wx0,wy0,wx1,wy1,wxs,wys,
		wymin,wymax,pulsefg);
}
void spatial_graph_2_par::print(ostream& out)
{
	spatial_graph_2::print(out);
}

// vec
spatial_graph_2_vec::spatial_graph_2_vec(display_window* window,
	nsl_vector* m) : spatial_graph_2(window)
{
	layer_ptr = m;
	layer0_ptr = m;
}
void spatial_graph_2_vec::read_from_database()
{
	parent_window->get_general_data("i0",&i0);
	parent_window->get_general_data("i1",&i1);

	imax = ((nsl_vector*) layer_ptr)->get_imax();

	parent_window->get_general_data("vec_type",&vec_type);

	if (i0 < 0) 
	{
		i0 = 0;
		parent_window->set_general_data("i0",i0);
	}
	if (i1 > imax-1) 
	{
		i1 = imax-1;
		parent_window->set_general_data("i1",i1);
	}
	if (i1 < i0)
	{
		i0 = 0;
		i1 = imax-1;
		parent_window->set_general_data("i0",i0);
		parent_window->set_general_data("i1",i1);
	}

	if (vec_type == 0)
	   parent_window->set_win_sector(0,i0,0,i1,1,imax); // update win sector
	else
	   parent_window->set_win_sector(i0,0,i1,0,imax,1); // update win sector
	spatial_graph_2::read_from_database(); // read in new win sector
}
void spatial_graph_2_vec::write_to_database()
{
	spatial_graph_2::write_to_database();
}
void spatial_graph_2_vec::display()
{
	num_type* m = ((nsl_vector*) layer_ptr)->get_vector();

	draw_spatial_graph_2_vector(canvas,m,wx0,wy0,wx1,wy1,wxs,wys,
		i0,i1,wymin,wymax,pulsefg,vec_type);
}
void spatial_graph_2_vec::print(ostream& out)
{
	spatial_graph_2::print(out);
}

// mat
spatial_graph_2_mat::spatial_graph_2_mat(display_window* window,
	nsl_matrix* m) : spatial_graph_2(window)
{
	layer_ptr = m;
	layer0_ptr = m;
}
void spatial_graph_2_mat::read_from_database()
{
	parent_window->get_general_data("i0",&i0);
	parent_window->get_general_data("i1",&i1);
	parent_window->get_general_data("j0",&j0);
	parent_window->get_general_data("j1",&j1);

	imax = ((nsl_matrix*) layer_ptr)->get_imax();
	jmax = ((nsl_matrix*) layer_ptr)->get_jmax();

	if (i0 < 0) 
	{
		i0 = 0;
		parent_window->set_general_data("i0",i0);
	}
	if (i1 > imax-1) 
	{
		i1 = imax-1;
		parent_window->set_general_data("i1",i1);
	}
	if (i1 < i0)
	{
		i0 = 0;
		i1 = imax-1;
		parent_window->set_general_data("i0",i0);
		parent_window->set_general_data("i1",i1);
	}

	if (j0 < 0) 
	{
		j0 = 0;
		parent_window->set_general_data("j0",j0);
	}
	if (j1 > jmax-1) 
	{
		j1 = jmax-1;
		parent_window->set_general_data("j1",j1);
	}
	if (j1 < j0)
	{
		j0 = 0;
		j1 = jmax-1;
		parent_window->set_general_data("j0",j0);
		parent_window->set_general_data("j1",j1);
	}

	parent_window->set_win_sector(i0,j0,i1,j1,imax,jmax);//update win sector
	spatial_graph_2::read_from_database(); // read in new win sector
}
void spatial_graph_2_mat::write_to_database()
{
	spatial_graph_2::write_to_database();
}
void spatial_graph_2_mat::display()
{
/*	num_type** m = ((nsl_matrix*) layer_ptr)->get_matrix();

	int wy00 = wy0;
	int wy11 = wy00 + wys;
	for (int i=y0; i<=y1; i++)
	{
		draw_spatial_graph_2_vector(canvas,m,
			wx0,wy00,wx1,wy11,wxs,wys,x0,x1,wymin,wymax,pulsefg);
		wy00 = wy00 + wys;
		wy11 = wy11 + wys;
	}*/
	cmd_error("Unable to display matrix as vectors");
}
void spatial_graph_2_mat::print(ostream& out)
{
	spatial_graph_2::print(out);
}
