//
// 	text_object.c
//

# include "nsl.h"
# include "nsl_headers.h"
# include "nsl_winds.h"

extern int set_text_label(Canvas,int,int,char*);

// text object
text_object::text_object(display_window* window,char* str,int index) 
	: canvas_object(window,str,"text",index)
{
}
text_object::~text_object()
{
}

// update
void text_object::read_from_database()
{
	int ival = 0;
	float fval = 0;
	string sval;

	int type = parent_window->get_general_data_type(name);

	switch (type)
	{
	case 1:
		parent_window->get_general_data(name,&ival);
		sprintf(text,"%s%d",label,ival);
		break;
	case 2:
		parent_window->get_general_data(name,&fval);
		sprintf(text,"%s%.2f",label,fval);
		break;
	case 3:
		strcpy(sval,"");
		parent_window->get_general_data(name,sval);
		sprintf(text,"%s%s",label,sval);
		break;
	default:
		cmd_error("*** text_object::read_from_database ***");
		cmd_error("Unknown data type: ",type);
		
	}
}
void text_object::write_to_database()
{
}

// display
void text_object::display()
{
	if (loc_fg == 1)
		wy = parent_window->get_height() - 12;
	else
		wy = 5;

	if (able_fg == 1 && redraw_fg == 1)
		set_text_label(canvas,wx,wy,text);
}

