 
/*********************************************/
/*	saccade.c			     */
/*********************************************/

#  include "nsl_include.h" 
#  include "pfd_params.h"

extern nsl_matrix NSLwinnertakeall(nsl_matrix& );
extern nsl_matrix NSLeyemove(nsl_matrix&, nsl_data&, nsl_data&);
extern nsl_matrix NSLshift(nsl_data&,nsl_data&, nsl_data&);
extern nsl_matrix 
	NSLXshift(nsl_data&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern nsl_matrix 
	NSLX2shift(nsl_data&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);


NETWORK(SACCADE);

INPUT_MAT(INP,27,27);		// input layers
INPUT_MAT(Fixation,27,27);
INPUT_MAT(TgtA,27,27);
INPUT_MAT(TgtB,27,27);
INPUT_MAT(STIMULATION,9,9);

ROW_VEC(P,329);
ROW_VEC(LTOPO,9);		
ROW_VEC(RTOPO,9);
ROW_VEC(LST,9);
ROW_VEC(RST,9); 
COL_VEC(UTOPO,9);
COL_VEC(DTOPO,9);
COL_VEC(UST,9);
COL_VEC(DST,9);

MATRIX(LWEIGHTS,9,9);
MATRIX(RWEIGHTS,9,9);
MATRIX(UWEIGHTS,9,9);
MATRIX(DWEIGHTS,9,9);
MATRIX(LSTM,9,9);
MATRIX(RSTM,9,9);
MATRIX(USTM,9,9);
MATRIX(DSTM,9,9);
MATRIX(ltrig,9,9);
MATRIX(rtrig,9,9);
MATRIX(utrig,9,9);
MATRIX(dtrig,9,9);

MATRIX(WtaMask,3,3);
MATRIX(LMASK,9,9);
MATRIX(RMASK,9,9);
MATRIX(UMASK,9,9);
MATRIX(DMASK,9,9);
MATRIX(llbn,9,9);
MATRIX(lllbn,9,9);
MATRIX(llbnwta,9,9);
MATRIX(LLBN,9,9);
MATRIX(Lmlbn,9,9);
MATRIX(LMLBN,9,9);
MATRIX(Rmlbn,9,9);
MATRIX(RMLBN,9,9);
MATRIX(Umlbn,9,9);
MATRIX(UMLBN,9,9);
MATRIX(Dmlbn,9,9);
MATRIX(DMLBN,9,9);
MATRIX(deltal,9,9);
MATRIX(deltar,9,9);
MATRIX(deltau,9,9);
MATRIX(deltad,9,9);
DATA(LTRIG);
DATA(LTRIGN);
DATA(RTRIG);
DATA(RTRIGN);
DATA(UTRIG);
DATA(UTRIGN);
DATA(DTRIG);
DATA(DTRIGN);
DATA(DELTALI);
DATA(DELTARI);
DATA(DELTAUI);
DATA(DELTADI);
DATA(DELTAL);
DATA(DELTAR);
DATA(DELTAU);
DATA(DELTAD);
DATA(lebn);
DATA(LEBN);
DATA(rebn);
DATA(REBN);
DATA(uebn);
DATA(UEBN);
DATA(debn);
DATA(DEBN);
DATA(lri);
DATA(rri);
DATA(uri);
DATA(dri);
DATA(LRI);
DATA(RRI);
DATA(URI);
DATA(DRI);
DATA(lpause);
DATA(LPAUSE);
DATA(rpause);
DATA(RPAUSE);	
DATA(upause);
DATA(UPAUSE);
DATA(dpause);
DATA(DPAUSE);

DATA(RTN);
DATA(RTNDELAY);
DATA(RTNCHANGE);

DATA(LTN);
DATA(LTNDELAY);
DATA(LTNCHANGE);

DATA(UTN);
DATA(UTNDELAY);
DATA(UTNCHANGE);

DATA(DTN);
DATA(DTNDELAY);
DATA(DTNCHANGE);

DATA(RTNDELAY2);
DATA(RTNDELAY3);
DATA(RTNCHANGE2);

DATA(LTNDELAY2);
DATA(LTNDELAY3);
DATA(LTNCHANGE2);

DATA(UTNDELAY2);
DATA(UTNDELAY3);
DATA(UTNCHANGE2);

DATA(DTNDELAY2);
DATA(DTNDELAY3);
DATA(DTNCHANGE2);


DATA(LMN);
DATA(RMN);
DATA(UMN);
DATA(DMN);
DATA(EyeHleft);
DATA(EyeH);
DATA(EyeV);
DATA(EyeVdown);
DATA(HTHETA);
DATA(VTHETA);
DATA(HV);
DATA(VV);
MATRIX(M,9,9);
MATRIX(M2,9,9);
MATRIX(M3,9,9);


DATA(BURSTERS);
DATA(saccadebool);
MATRIX(retina1,9,9);
MATRIX(retina,9,9);
MATRIX(RETINA,9,9);
MATRIX(SACCADEMASK,9,9);
MATRIX(mt,9,9);
MATRIX(MT,9,9);
MATRIX(v4,9,9);
MATRIX(V4,9,9);
MATRIX(v2,9,9);
MATRIX(V2,9,9);
MATRIX(v1,9,9);
MATRIX(V1,9,9);
MATRIX(lgn,9,9);
MATRIX(LGN,9,9);
MATRIX(pp,9,9);
MATRIX(PP,9,9);
MATRIX(ppqv,9,9);
MATRIX(PPqv,9,9);

MATRIX(fef,9,9); 
MATRIX(FEF,9,9);
MATRIX(fvsmask,9,9);
MATRIX(FVSMASK,9,9);
MATRIX(fmimask,9,9);
MATRIX(FMIMASK,9,9);
MATRIX(FOVOFF,9,9);
MATRIX(fef_vs,9,9);
MATRIX(FEFvs,9,9);
MATRIX(fef_vm,9,9);
MATRIX(fef_vm1,9,9);
MATRIX(FEFvm,9,9);
MATRIX(fef_sm,9,9);
MATRIX(FEFsm,9,9);
MATRIX(fef_ms,9,9);
MATRIX(FEFms,9,9);
MATRIX(fovea,9,9);
MATRIX(FOVEA,9,9);
DATA(fd);
DATA(fefswitch);
DATA(FEFSWITCH);
DATA(fefgate);
DATA(FEFGATE);
MATRIX(FOn,9,9);
MATRIX(cd_vs,9,9);
MATRIX(CDvs,9,9);
MATRIX(cd_vm,9,9);
MATRIX(CDvm,9,9);
MATRIX(cd_sm,9,9);
MATRIX(CDsm,9,9);
MATRIX(snr_sm,9,9);
MATRIX(SNRsm,9,9);
MATRIX(snr_vs,9,9);
MATRIX(SNRvs,9,9);
MATRIX(sc_ms,9,9);
MATRIX(SCms,9,9);
MATRIX(qvmask1,9,9);
MATRIX(qvmask2,9,9); DATA(QVFACTOR); DATA(QVctr);DATA(Oblique);
MATRIX(QVMASK,9,9);
MATRIX(qv,9,9);
MATRIX(QV,9,9);
MATRIX(sc_qv,9,9);
MATRIX(SCqv,9,9);
MATRIX(sc_vs,9,9);
MATRIX(SCvs,9,9);

MATRIX(sc_sup,9,9);
MATRIX(SCsup,9,9);

MATRIX(sc,9,9);
MATRIX(sc_wta,9,9);
MATRIX(SC,9,9);
MATRIX(SC_Delay,9,9);
MATRIX(thal_sm,9,9);
MATRIX(THsm,9,9);


INIT_MODULE(saccade_init)
{
	QVctr = 1;
	QVFACTOR = 1600;
	Oblique = 1;
	LLBN = 0;
	PPqv = 0;
	SC_Delay = 0;

	LTN = 154.0;
	RTN = 154;
	UTN = 154;
	DTN = 154;

	RTNDELAY2 = 154;
	RTNDELAY3 = 154;
	RTNCHANGE2 = 0;

	LTNDELAY2 = 154;
	LTNDELAY3 = 154;
	LTNCHANGE2 = 0;

	UTNDELAY2 = 154;
	UTNDELAY3 = 154;
	UTNCHANGE2 = 0;

	DTNDELAY2 = 154;
	DTNDELAY3 = 154;
	DTNCHANGE2 = 0;

	RTNDELAY = 154;
	LTNDELAY = 154;
	UTNDELAY = 154;
	DTNDELAY = 154;
	SNRvs = 80;
	SNRsm = 100;
}


///////////////////
//saccade generator ala Scudder;  These arrays represent the increased
//density of SC projection to LLBNs as a function of increase eccentricity
// in SC. Function: spatial to temporal transformation.
//////////////////////////  

// long lead burst neurons for left, right up and down

RUN_MODULE(saccade_input)
{
	INP.run();
	STIMULATION.run();
}

RUN_MODULE(saccade_llbn)
{
	DIFF.eq(llbn,P.elem(llbn_tm)) = -llbn + P.elem(llbn_k1)*SC +
		P.elem(llbn_k2)*FEFvs + P.elem(llbn_k3)*FEFms;
	llbnwta = NSLwinnertakeall(llbn);
}

RUN_MODULE(saccade_LLBN)
{
	LLBN = NSLsaturation(llbnwta,P.elem(LLBN_kx1),P.elem(LLBN_kx2),
			     P.elem(LLBN_ky1),P.elem(LLBN_ky2));
}


RUN_MODULE(saccade_mlbn)
{
	DIFF.eq(Lmlbn,P.elem(Lmlbn_tm)) = -Lmlbn + (LSTM^LLBN);
	DIFF.eq(Rmlbn,P.elem(Rmlbn_tm)) = -Rmlbn + (RSTM^LLBN);
	DIFF.eq(Umlbn,P.elem(Umlbn_tm)) = -Umlbn + (USTM^LLBN);
	DIFF.eq(Dmlbn,P.elem(Dmlbn_tm)) = -Dmlbn + (DSTM^LLBN);
}
RUN_MODULE(saccade_MLBN)
{
	LMLBN = NSLsaturation(Lmlbn,P.elem(LMLBN_kx1),P.elem(LMLBN_kx2),
		P.elem(LMLBN_ky1),P.elem(LMLBN_ky2));
	RMLBN = NSLsaturation(Rmlbn,P.elem(RMLBN_kx1),P.elem(RMLBN_kx2),
		P.elem(RMLBN_ky1),P.elem(RMLBN_ky2));
	UMLBN = NSLsaturation(Umlbn,P.elem(UMLBN_kx1),P.elem(UMLBN_kx2),
		P.elem(UMLBN_ky1),P.elem(UMLBN_ky2));
	DMLBN = NSLsaturation(Dmlbn,P.elem(DMLBN_kx1),P.elem(DMLBN_kx2),
		P.elem(DMLBN_ky1),P.elem(DMLBN_ky2));
}



// EBNs for left, right up and down

RUN_MODULE(saccade_rebn)
{
	DIFF.eq(rebn,P.elem(rebn_tm)) = - rebn + RMLBN.max() -
 		P.elem(rebn_k1)*RPAUSE;
	DIFF.eq(lebn,P.elem(lebn_tm)) = - lebn + LMLBN.max() -
 		P.elem(lebn_k1)*LPAUSE;
	DIFF.eq(uebn,P.elem(uebn_tm)) = - uebn + UMLBN.max() -
 		P.elem(uebn_k1)*UPAUSE;
	DIFF.eq(debn,P.elem(debn_tm)) = - debn + DMLBN.max() -
 		P.elem(debn_k1)*DPAUSE;
}

RUN_MODULE(saccade_REBN)
{
	REBN =
 	  NSLramp(rebn,P.elem(REBN_k1),P.elem(REBN_k2),P.elem(REBN_k3));
	LEBN = 
	  NSLramp(lebn,P.elem(LEBN_k1),P.elem(LEBN_k2),P.elem(LEBN_k3));
	UEBN = 
	  NSLramp(uebn,P.elem(UEBN_k1),P.elem(UEBN_k2),P.elem(UEBN_k3));
	DEBN = 
	  NSLramp(debn,P.elem(DEBN_k1),P.elem(DEBN_k2),P.elem(DEBN_k3));
}

//////// restable integrator for change in right position


RUN_MODULE(saccade_pause)
{
//  right
	DIFF.eq(rtrig,P.elem(rtrig_tm)) = -rtrig + (RSTM^SC) + (RSTM^FEFvs) +
 		(RSTM^FEFms) - P.elem(rtrig_k1)*RMASK;

	DIFF.eq(rpause,P.elem(rpause_tm)) = -rpause + 
		P.elem(rpause_k1)*RTRIGN + DELTAR - RRI;

	rri = RRI + P.elem(rri_k1)*REBN - RPAUSE;
	deltar = (RMASK^RWEIGHTS);

//  left
	DIFF.eq(ltrig,P.elem(ltrig_tm)) = -ltrig + (LSTM^SC) + (LSTM^FEFvs) +
 		(LSTM^FEFms) - P.elem(ltrig_k1)*LMASK;

	DIFF.eq(lpause,P.elem(lpause_tm)) = -lpause + 
		P.elem(lpause_k1) *LTRIGN + DELTAL -  LRI;

	lri = LRI + P.elem(lri_k1)*LEBN - LPAUSE;
	deltal = (LMASK^LWEIGHTS);

//  up
	DIFF.eq(utrig,P.elem(utrig_tm)) = -utrig + (USTM^SC) + (USTM^FEFvs) +
 		(USTM^FEFms) - P.elem(utrig_k1)*UMASK;

	DIFF.eq(upause,P.elem(upause_tm)) = -upause + 
		P.elem(upause_k1) *UTRIGN + DELTAU - URI;

	uri = URI + P.elem(uri_k1)*UEBN - UPAUSE;
	deltau = (UMASK^UWEIGHTS);

//  down
	DIFF.eq(dtrig,P.elem(dtrig_tm)) = -dtrig + (DSTM^SC) + (DSTM^FEFvs) +
 		(DSTM^FEFms) - P.elem(dtrig_k1)*DMASK;

	DIFF.eq(dpause,P.elem(dpause_tm)) = -dpause + 
		P.elem(dpause_k1) *DTRIGN + DELTAD - DRI;

	dri = DRI + P.elem(dri_k1) *DEBN - DPAUSE;
	deltad = (DMASK^DWEIGHTS);
}

RUN_MODULE(saccade_PAUSE)
{
//  right	
	RTRIG.elem() = rtrig.max();
	RTRIGN = NSLramp(RTRIG,P.elem(RTRIGN_k1),
		 P.elem(RTRIGN_k2),P.elem(RTRIGN_k3));

	RRI = NSLramp(rri,P.elem(RRI_k1),
		P.elem(RRI_k2),P.elem(RRI_k3));

	RMASK = NSLstep(RMLBN,P.elem(RMASK_k1),
		P.elem(RMASK_k2),P.elem(RMASK_k3));

	DELTARI = deltar.max() - P.elem(DELTARI_k1)*RPAUSE;

	DELTAR = NSLramp(DELTARI,P.elem(DELTAR_k1),
		P.elem(DELTAR_k2),P.elem(DELTAR_k3));
	
	RPAUSE = NSLstep(rpause,P.elem(RPAUSE_k1),
		 P.elem(RPAUSE_k2),P.elem(RPAUSE_k3));


//  left	
	LTRIG.elem() = ltrig.max();

	LTRIGN = NSLramp(LTRIG,P.elem(LTRIGN_k1),
		P.elem(LTRIGN_k2),P.elem(LTRIGN_k3));

	LRI = NSLramp(lri,P.elem(LRI_k1),
		P.elem(LRI_k2),P.elem(LRI_k3));

	LMASK = NSLstep(LMLBN,P.elem(LMASK_k1),
		P.elem(LMASK_k2),P.elem(LMASK_k3));

	DELTALI = deltal.max() - P.elem(DELTALI_k1)*LPAUSE;

	DELTAL = NSLramp(DELTALI,P.elem(DELTAL_k1),
		P.elem(DELTAL_k2),P.elem(DELTAL_k3));

	LPAUSE = NSLstep(lpause,P.elem(LPAUSE_k1),
		P.elem(LPAUSE_k2),P.elem(LPAUSE_k3));


//  up	
	UTRIG.elem() = utrig.max();
	UTRIGN = NSLramp(UTRIG,P.elem(UTRIGN_k1),
		P.elem(UTRIGN_k2),P.elem(UTRIGN_k3));

	URI = NSLramp(uri,P.elem(URI_k1),
		P.elem(URI_k2),P.elem(URI_k3));

	UMASK = NSLstep(UMLBN,P.elem(UMASK_k1),
		P.elem(UMASK_k2),P.elem(UMASK_k3));
	
	DELTAUI = deltau.max() - P.elem(DELTAUI_k1)*UPAUSE;

	DELTAU = NSLramp(DELTAUI,P.elem(DELTAU_k1),
		P.elem(DELTAU_k2),P.elem(DELTAU_k3));

	UPAUSE = NSLstep(upause,P.elem(UPAUSE_k1),
		P.elem(UPAUSE_k2),P.elem(UPAUSE_k3));



//  down	
	DTRIG.elem() = dtrig.max();
	DTRIGN = NSLramp(DTRIG,P.elem(DTRIGN_k1),
		P.elem(DTRIGN_k2),P.elem(DTRIGN_k3));

	DRI = NSLramp(dri,P.elem(DRI_k1),
		P.elem(DRI_k2),P.elem(DRI_k3));

	DMASK = NSLstep(DMLBN,P.elem(DMASK_k1),
		P.elem(DMASK_k2),P.elem(DMASK_k3));

	DELTADI = deltad.max() - P.elem(DELTADI_k1)*DPAUSE;

	DELTAD = NSLramp(DELTADI,P.elem(DELTAD_k1),
		P.elem(DELTAD_k2),P.elem(DELTAD_k3));

	DPAUSE = NSLstep(dpause,P.elem(DPAUSE_k1),
		P.elem(DPAUSE_k2),P.elem(DPAUSE_k3));
}



//////////////////////////////
// tonic neurons for left right up and down

//////////////////////
//  FEF collision temporal dynamic remapping

RUN_MODULE(saccade_temporal_remapping)
{
	fefswitch.elem() = STIMULATION.max();
	DIFF.eq(fefgate,P.elem(fefgate_tm)) = - fefgate + FEFSWITCH;
}

RUN_MODULE(saccade_TEMPORAL_REMAPPING)
{
	FEFSWITCH = NSLstep(fefswitch,P.elem(FEFSWITCH_k1),
		P.elem(FEFSWITCH_k2),P.elem(FEFSWITCH_k3));

	FEFGATE = NSLstep(fefgate,P.elem(FEFGATE_k1),
		P.elem(FEFGATE_k2),P.elem(FEFGATE_k3));

	DIFF.eq(RTNDELAY2,P.elem(RTNDELAY2_tm)) = - RTNDELAY2 + RTN;
	DIFF.eq(RTNDELAY3,P.elem(RTNDELAY3_tm)) = - RTNDELAY3 + RTN;
	DIFF.eq(RTNCHANGE2,P.elem(RTNCHANGE2_tm)) = - RTNCHANGE2 +
		 RTNDELAY2 - RTNDELAY3;

	DIFF.eq(LTNDELAY2,P.elem(LTNDELAY2_tm)) = - LTNDELAY2 + LTN;
	DIFF.eq(LTNDELAY3,P.elem(LTNDELAY3_tm)) = - LTNDELAY3 + LTN;
	DIFF.eq(LTNCHANGE2,P.elem(LTNCHANGE2_tm)) = - LTNCHANGE2 +
		 LTNDELAY2 - LTNDELAY3;

	DIFF.eq(UTNDELAY2,P.elem(UTNDELAY2_tm)) = - UTNDELAY2 + UTN;
	DIFF.eq(UTNDELAY3,P.elem(UTNDELAY3_tm)) = - UTNDELAY3 + UTN;
	DIFF.eq(UTNCHANGE2,P.elem(UTNCHANGE2_tm)) = - UTNCHANGE2 +
		 UTNDELAY2 - UTNDELAY3;

	DIFF.eq(DTNDELAY2,P.elem(DTNDELAY2_tm)) = - DTNDELAY2 + DTN;
	DIFF.eq(DTNDELAY3,P.elem(DTNDELAY3_tm)) = - DTNDELAY3 + DTN;
	DIFF.eq(DTNCHANGE2,P.elem(DTNCHANGE2_tm)) = - DTNCHANGE2 + 
		DTNDELAY2 - DTNDELAY3;

}


//from (Robinson, 1970) we have the following for firing rate, D, as a
//function of location (theta) and velocity (d.theta/d.t):
// 		D = k*theta + r*d.theta/d.t + c
//		  = 2.75*theta + 0.9* d.theta/d.t + 154;
// this simplified linear sytem for the mapping of oculomotor neuron firing
// rates to location and velocity of eye will be used in our preliminary
// model. 



// MOTOR NEURONS
RUN_MODULE(saccade_MN)
{
	LMN = LEBN + LTN;
	RMN = REBN + RTN;
	UMN = UEBN + UTN;
	DMN = DEBN + DTN;
}


	//NOTE: this represents gaze angle, and is not used in the
	//model, but only as an indicator of eye position for experimenter

RUN_MODULE(saccade_EYE_POSITION_AND_VELOCITY) 
{
	EyeH = P.elem(EyeH_k2)*RTN - 56;
	EyeV = P.elem(EyeV_k2)*UTN - 56; 

	EyeVdown = P.elem(EyeVdown_k2)*DTN - 56;
	EyeHleft = P.elem(EyeHleft_k2)*LTN - 56;

	VV = P.elem(VV_k1)*UEBN - P.elem(VV_k1)*DEBN + 
		P.elem(VV_k2)*UTNCHANGE - P.elem(VV_k3)*DTNCHANGE;

	HV = P.elem(HV_k1)*REBN - P.elem(HV_k1)*LEBN + 
		P.elem(HV_k2)*RTNCHANGE - P.elem(HV_k3)*LTNCHANGE;
	HTHETA = P.elem(HTHETA_k1)*EyeH;
	VTHETA = P.elem(VTHETA_k1)*EyeV;
}

// CHANGE IN POSITION FOR QV SHIFT

RUN_MODULE(saccade_tonic_changes)
{
	DIFF.eq(RTNDELAY,P.elem(RTNDELAY_tm)) = - RTNDELAY + RTN;
	DIFF.eq(LTNDELAY,P.elem(LTNDELAY_tm)) = - LTNDELAY + LTN;
	DIFF.eq(UTNDELAY,P.elem(UTNDELAY_tm)) = - UTNDELAY + UTN;
	DIFF.eq(DTNDELAY,P.elem(DTNDELAY_tm)) = - DTNDELAY + DTN;
}

RUN_MODULE(saccade_TN)
{
//on each timestep,the tonic component uppdated by 2.75*(change in theta).
// Change in theta is angular velocity * time =
//			   EBN*(1/R)  * (simuation time step)
	LTN = LTN + P.elem(LTN_k1)*LEBN - P.elem(LTN_k1)*REBN - 
		FEFGATE*LTNCHANGE2;
	RTN = RTN + P.elem(RTN_k1)*REBN - P.elem(RTN_k1)*LEBN - 
		FEFGATE*RTNCHANGE2;
	UTN = UTN + P.elem(UTN_k1)*UEBN - P.elem(UTN_k1)*DEBN -
		FEFGATE*UTNCHANGE2;
	DTN = DTN + P.elem(DTN_k1)*DEBN - P.elem(LTN_k1)*UEBN -
		FEFGATE*DTNCHANGE2;
}



RUN_MODULE(saccade_TONIC_CHANGES)
{
	RTNCHANGE = RTN - RTNDELAY;
	LTNCHANGE = LTN - LTNDELAY;
	UTNCHANGE = UTN - UTNDELAY;
	DTNCHANGE = DTN - DTNDELAY;
}

RUN_MODULE(saccade_BURSTERS)
{
BURSTERS = UEBN + DEBN + LEBN + REBN;
saccadebool = NSLstep(BURSTERS,P.elem(saccadebool_k1),
	      P.elem(saccadebool_k2),P.elem(saccadebool_k3));
SACCADEMASK = saccadebool;
}

RUN_MODULE(saccade_retina)
{
	retina1 = NSLeyemove(INP,HTHETA,VTHETA);
	DIFF.eq(retina,P.elem(retina_tm)) = - retina + retina1;
}

RUN_MODULE(saccade_RETINA)
{
	RETINA = (SACCADEMASK^retina);
}


RUN_MODULE(saccade_VISCORTEX)
{
	DIFF.eq(PP,P.elem(PP_tm)) = - PP + MT;
	DIFF.eq(MT,P.elem(MT_tm)) = - MT + V4;
	DIFF.eq(V4,P.elem(V4_tm)) = - V4 + V2;
	DIFF.eq(V2,P.elem(V2_tm)) = - V2 + V1;
	DIFF.eq(V1,P.elem(V1_tm)) = - V1 + LGN;
	DIFF.eq(LGN,P.elem(LGN_tm)) = - LGN + RETINA;
}


RUN_MODULE(saccade_PPqv)
{
	qvmask1 = NSLshift(HV,VV,QVFACTOR);

	qvmask2 = NSLX2shift(HV,VV,QVFACTOR,QVctr,Oblique);
	QVMASK = P.elem(QVMASK_k1)*qvmask1 + P.elem(QVMASK_k2)*qvmask2 ;
	ppqv = PP + P.elem(ppqv_k3)*M + QVMASK*PPqv -P.elem(ppqv_k2)*FOn-
			M3*SC_Delay;
	PPqv = NSLsigma(ppqv,P.elem(PPqv_kx1),P.elem(PPqv_kx2),
			P.elem(PPqv_ky1),P.elem(PPqv_ky2));
}

RUN_MODULE(saccade_MASKS)
{
	fvsmask = P.elem(fvsmask_k1);
	fmimask = P.elem(fmimask_k1);
	FVSMASK = fvsmask;
	FMIMASK = fmimask;
}

RUN_MODULE(saccade_fef)
{
	DIFF.eq(fef_vs,P.elem(fef_vs_tm)) = - fef_vs + (PPqv^FVSMASK) - 
		P.elem(fef_vs_k2)*FOn  + P.elem(fef_vs_k1)*STIMULATION;

	DIFF.eq(fef_vm,P.elem(fef_vm_tm))= - fef_vm + (PPqv^FMIMASK);


	fef_vm1 = (fef_vm^SACCADEMASK);	

	DIFF.eq(fef_sm,P.elem(fef_sm_tm)) = - fef_sm + P.elem(fef_sm_k4)*THsm + 
		P.elem(fef_sm_k2)*FEFvm - P.elem(fef_sm_k6)*FOn;

	DIFF.eq(fef_ms,P.elem(fef_ms_tm)) = - fef_ms +
		P.elem(fef_ms_k1)*FEFsm - P.elem(fef_ms_k2)*FOn;
}


RUN_MODULE(saccade_FEF)
{
	FEFvs = NSLsigma(fef_vs,P.elem(FEFvs_x1),P.elem(FEFvs_x2),
		P.elem(FEFvs_y1),P.elem(FEFvs_y2)) + 
		P.elem(FEFvs_k1) * STIMULATION;

	FEFvm = NSLsigma(fef_vm,P.elem(FEFvm_x1),P.elem(FEFvm_x2),
		P.elem(FEFvm_y1),P.elem(FEFvm_y2));

	FEFsm = NSLsigma(fef_sm,P.elem(FEFsm_x1),P.elem(FEFsm_x2),
		P.elem(FEFsm_y1),P.elem(FEFsm_y2));

	FEFms = NSLsigma(fef_ms,P.elem(FEFms_x1),P.elem(FEFms_x2),
		P.elem(FEFms_y1),P.elem(FEFms_y2));
}


RUN_MODULE(saccade_fovea)
{
	M.elem(4,4) = 1;
	fovea = (M^RETINA);
	FOVEA = NSLstep(fovea,P.elem(FOVEA_x1),P.elem(FOVEA_y1),
			P.elem(FOVEA_y2));
	FOn = FOVEA.elem(4,4);
}

RUN_MODULE(saccade_M_M2)
{
	M2.elem(3,3) = 1;
	M2.elem(3,4) = 1;
	M2.elem(3,5) = 1;
	M2.elem(4,3) = 1;
	M2.elem(4,4) = 1;
	M2.elem(4,5) = 1;
	M2.elem(5,3) = 1;
	M2.elem(5,4) = 1;
	M2.elem(5,5) = 1;

	M3 = P.elem(M3_k1) * M2;	
}

RUN_MODULE(saccade_caudate)
{
	DIFF.eq(cd_vs,P.elem(cd_vs_tm)) = - cd_vs + FEFvs - 
		P.elem(cd_vs_k2)*FOn;

	DIFF.eq(cd_vm,P.elem(cd_vm_tm)) = - cd_vm + FEFvm;

	DIFF.eq(cd_sm,P.elem(cd_sm_tm)) = - cd_sm + CDvm +
		P.elem(cd_sm_k1)*FEFsm;
}

RUN_MODULE(saccade_CAUDATE)
{
	CDvs = NSLsigma(cd_vs,P.elem(CDvs_x1),P.elem(CDvs_x2),
		P.elem(CDvs_y1),P.elem(CDvs_y2));

	CDvm = NSLsigma(cd_vm,P.elem(CDvm_x1),P.elem(CDvm_x2),
		P.elem(CDvm_y1),P.elem(CDvm_y2));

	CDsm = NSLsigma(cd_sm,P.elem(CDsm_x1),P.elem(CDsm_x2),
		P.elem(CDsm_y1),P.elem(CDsm_y2));
}

RUN_MODULE(saccade_snr)
{
	DIFF.eq(snr_vs,P.elem(snr_vs_tm)) = - snr_vs + P.elem(snr_vs_k1)*CDvs; 
	DIFF.eq(snr_sm,P.elem(snr_sm_tm)) = - snr_sm + P.elem(snr_sm_k1)*CDsm; 
}

RUN_MODULE(saccade_SNR)
{
	SNRvs = NSLsigma(snr_vs,P.elem(SNRvs_x1),P.elem(SNRvs_x2),
			P.elem(SNRvs_y1),P.elem(SNRvs_y2));

	SNRsm = NSLsigma(snr_sm,P.elem(SNRsm_x1),P.elem(SNRsm_x2),
			P.elem(SNRsm_y1),P.elem(SNRsm_y2));
}

RUN_MODULE(saccade_sc)  
{
	DIFF.eq(sc_sup,P.elem(sc_sup_tm)) = - sc_sup -
		 P.elem(sc_sup_k1)*FOn + P.elem(sc_sup_k2)*RETINA;

	DIFF.eq(sc_vs,P.elem(sc_vs_tm)) = -sc_vs + FEFvs - 
		P.elem(sc_vs_k1)*SNRvs - FOVEA - P.elem(sc_vs_k3)*FOn;

	DIFF.eq(sc_qv,P.elem(sc_qv_tm)) = 
			-sc_qv + NSLwinnertakeall(PPqv);

	DIFF.eq(sc_ms,P.elem(sc_ms_tm)) = -sc_ms +  
		P.elem(sc_ms_k1)*FEFms - SNRsm - FOVEA;

	DIFF.eq(sc,P.elem(sc_tm)) = -sc + P.elem(sc_k1)*SCvs + 
		P.elem(sc_k2)*SCms + P.elem(sc_k3)*SCqv -
		P.elem(sc_k4)*FOn  + P.elem(sc_k5)*STIMULATION +
		P.elem(sc_k6)*(SCsup - FOn);

	sc_wta = NSLwinnertakeall(sc);
}

RUN_MODULE(saccade_SC)
{
	SCsup = NSLsigma(sc_sup,P.elem(SCsup_x1),P.elem(SCsup_x2),
		P.elem(SCsup_y1),P.elem(SCsup_y2));

	SCvs = NSLsigma(sc_vs,P.elem(SCvs_x1),P.elem(SCvs_x2),
		P.elem(SCvs_y1),P.elem(SCvs_y2));

	SCqv = (SACCADEMASK^sc_qv) - P.elem(SCqv_k1)*SNRvs;

	SCms = NSLsigma(sc_ms,P.elem(SCms_x1),P.elem(SCms_x2),
		P.elem(SCms_y1),P.elem(SCms_y2));

	SC = NSLsigma(sc_wta,P.elem(SC_x1),P.elem(SC_x2),
		P.elem(SC_y1),P.elem(SC_y2)) + P.elem(SC_k3)*STIMULATION;

	DIFF.eq(SC_Delay,P.elem(SC_Delay_tm)) = -SC_Delay + SC;
}

RUN_MODULE(saccade_thal)
{
	DIFF.eq(thal_sm,P.elem(thal_sm_tm)) = - thal_sm +
		P.elem(thal_sm_k3)*FEFsm - P.elem(thal_sm_k1)*SNRsm -
	        FOVEA - P.elem(thal_sm_k2)*(M3*SC_Delay);
}

RUN_MODULE(saccade_THAL)
{
	THsm = NSLsigma(thal_sm,P.elem(THsm_x1),P.elem(THsm_x2),
		P.elem(THsm_y1),P.elem(THsm_y2));
}


RUN_MODULE(saccade_SPATIO_TEMPORAL_TRANS)
{
LTOPO.elem(0) = 5.7;
LTOPO.elem(1) = 4.275;
LTOPO.elem(2) = 2.85;
LTOPO.elem(3) = 1.425;

RTOPO.elem(5) = 1.425;
RTOPO.elem(6) = 2.85;
RTOPO.elem(7) = 4.275;
RTOPO.elem(8) = 5.7;

UTOPO.elem(0) = 5.7;
UTOPO.elem(1) = 4.275;
UTOPO.elem(2) = 2.85;
UTOPO.elem(3) = 1.425;

DTOPO.elem(5) = 1.425;
DTOPO.elem(6) = 2.85;
DTOPO.elem(7) = 4.275;
DTOPO.elem(8) = 5.7;


}

RUN_MODULE(saccade_BRAINSTEM_LAYERS)
{
LWEIGHTS = NSLrow_vec_to_mat(LWEIGHTS,LTOPO);
RWEIGHTS = NSLrow_vec_to_mat(RWEIGHTS,RTOPO);
UWEIGHTS = NSLcol_vec_to_mat(UWEIGHTS,UTOPO);
DWEIGHTS = NSLcol_vec_to_mat(DWEIGHTS,DTOPO);
LSTM = P.elem(LSTM_K1)*NSLrow_vec_to_mat(LSTM,LTOPO);
RSTM = P.elem(RSTM_K1)*NSLrow_vec_to_mat(RSTM,RTOPO);
USTM = P.elem(USTM_K1)*NSLcol_vec_to_mat(USTM,UTOPO);
DSTM = P.elem(DSTM_K1)*NSLcol_vec_to_mat(DSTM,DTOPO);
}



